#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import MyGlobal
import pygtk
pygtk.require( "2.0" )
'Um auf Heidehain-Maschine mit kurze Zeiten testen zu können, soll "Simulate" auf 0 und "SUMULATE_ITNC" auf 1 gesetzt werden'
'Um auf Widnow mit kurze Zeiten testen zu können, soll Simulate auf 1 und SUMULATE_ITNC auf 1 gesetzt werden'
'Um auf Heidehain-Maschine mit richtigen Zeiten testen zu können, soll Simulate auf 0 und SUMULATE_ITNC auf 0 gesetzt werden'
Simulate = 0
SUMULATE_ITNC = 0
if(Simulate == 0):
    import pyjh
    pyjh.require(MyGlobal.pyjh_version)
    import jh
    import jh.gtk

from gtk import Fixed
from gtk import WINDOW_TOPLEVEL
from gtk import STATE_NORMAL
from gtk import Window
from gtk import main
from gtk import main_quit
from gtk import Image
from gtk import VBox
from gtk import Label
from gtk import DrawingArea
from gtk import ToggleButton
from gtk import TextView
from gtk import DrawingArea
from gtk import HBox
from gtk import TextTag
from gtk import Button
from gtk import ToggleButton
from gtk import HBox
import gtk.gdk
import string
import pango
import os
import DMG_XMLParser
from struct import *
import gobject
import time
import DMG_Version


SATimeInterval = 10 * 60
com = None
unit = " h "
if(Simulate == 1 or SUMULATE_ITNC == 1):
    unit = " s "

if Simulate == 0:
    import DMGCommITNC
    com = DMGCommITNC.DMGCommITNC()

pangoFontBody = pango.FontDescription("Sans 9")
pangoFontHead = pango.FontDescription("Sans 12")
pangoCommentFont = pango.FontDescription("Sans 8")

'Font-Discription'
if Simulate == 0:
    pangoFontBody = pango.FontDescription("HDH 9")
    pangoFontHead = pango.FontDescription("HDH 12")
    pangoCommentFont = pango.FontDescription("HDH 8")

pangoCommentFont.set_style( pango.STYLE_NORMAL )
pangoCommentFont.set_weight( pango.WEIGHT_BOLD )

pangoFontBody.set_style( pango.STYLE_NORMAL )
pangoFontBody.set_weight( pango.WEIGHT_BOLD )

pangoFontHead.set_style( pango.STYLE_NORMAL )
pangoFontHead.set_weight( pango.WEIGHT_BOLD )

'---------------------------PicturCode------------------------'
YELLOW_STATIC           = 0
YELLOW_BLINK            = 1
ORANGE_STATIC           = 2
ORANGE_BLINK            = 3
RED_STATIC              = 4
RED_BLINK               = 5
BLUE_STATIC             = 6
STANDARD_LEVEL          = 0
MAINTENANCE_LEVEL       = 1
INSPECTION_LEVEL        = 2


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse DMGMessagesPage hat die folgenden Aufgaben:
1). gibt die Meldungen an, die zu Intervale gehören
Autor: Waddah Ostah
Datum: 2.12.2010
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
class DMGMessagesPage:
    def __init__(self):
        self.m_Head         = None
        self.m_Body         = None
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse DMGMachineCheckMessagesData hat die folgenden Aufgaben:
1).gibt die Daten der Defnitionsdatei an
2). gibt die Zeiten den Wartungsintervale und Inspektionsintervale an.
3). gibt die Meldungen an, die zu Intervale gehören
Autor: Waddah Ostah
Datum: 2.12.2010
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
class DMGMachineCheckMessagesData:
    def __init__(self):
        self.m_ID                        = None
        self.m_Interval                  = None
        self.m_Level                     = None
        self.m_Comment                   = None
        self.m_DefinitionFileMessages    = []

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse DMGMachineCheckTimeData hat die folgenden Aufgaben:
1). gibt die zeiten der  aufgetretenen Wartungsmeldungen bzw. die zeiten der quittierten Meldungen
Autor: Waddah Ostah
Datum: 2.12.2010
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
class DMGMachineCheckTimeData:
    def __init__(self):
        self.m_Date      = ""
        self.m_Time      = ""
        self.m_pgmHours  = ""

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse DMGMachineCheckLogFileData hat die folgenden Aufgaben:
1). gibt die Daten der Logdatei an
2). gibt an, die Wartungsintervalle oder Inspektionsintervalle noch nicht quittiert sind.
Autor: Waddah Ostah
Datum: 2.12.2010
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
class DMGMachineCheckLogFileData:
    def __init__(self):
        self.m_ID                = 0
        self.m_Occurrence        = DMGMachineCheckTimeData()
        self.m_Acknowledgement   = DMGMachineCheckTimeData()
        self.m_User              = 0
        self.m_Reason            = ""
        self.m_Level             = ""
        self.m_ShowMessage       = False
        self.m_AppearanceCounter = 0
        self.m_PageNumber        = 0
        self.m_LastTime          = 0
        self.m_ReminderActive    = False


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse DMGMachineCheckSmartKeyData hat die folgenden Aufgaben:
1). gibt den ID und password an
Autor: Waddah Ostah
Datum: 2.12.2010
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
class DMGMachineCheckSmartKeyData:
    def __init__(self):
        self.m_ID               = 0
        self.m_PW               = 0

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse DMGBasisTechnologie hat die folgenden Aufgaben:
1). gibt den BT und MTYP an
Autor: Waddah Ostah
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
class DMGBasisTechnologie:
    def __init__(self):
        self.m_BT               = ""
        self.m_MTYP             = ""


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse DMGMachineCheckData hat die folgenden Aufgaben:
1). verwaltet die Konfigurationdatei, Definitionsdatei und logdatei
2). verwaltet die Wartungsintervalle bzw. Inspektionsintervall
3). liest die Betriebsstundenzähler(Maschineeinschaltzeit, Programmlaufzeit) und schreibt die
    zugehörige Werte in Konfigurationsdatei
4). verwaltet die Anzeige von Wartungsmeldungen bzw. Inspektionsmeldung
5). prüft, ob das PlugIN-Fenster in vordergrung sein sollte.
6). verwaltet, ob die Anzeige im Fenster jede Sekunde blinken soll.
7). verwaltet die Reminder-Zähler.
8). regestriert das ParentFenster, um nachrichten an dem Fenster zu senden
9). verwaltet die Sprachumschaltung
Autor: Waddah Ostah
Datum: 1.12.2010
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
if(Simulate == 0):
    PATH                = jh.ResPath("PLC:\\PYTHON\\UPPER_SCREEN\\")
    LanguagePATH        = jh.ResPath(PATH + "lng\\")
    BitmapPATH          = jh.ResPath(PATH + "ico\\")
else:
    PATH = ""
    LanguagePATH        = "lng\\"
    BitmapPATH          = "ico\\"


KonfigFileName          = LanguagePATH + "dmgMachineCheckConfig.xml"
LogFileName             = LanguagePATH + "dmgMachineCheckActions.log"
DefinitionFile          = LanguagePATH + "dmgMachineCheckMessages_%s.enc"
LanguageFileName        = LanguagePATH + "DMG_MachineCheck_%s.txt"
BaseTechnologieFileName = LanguagePATH + "basetechnology.xml"
ICNON_SYNTAX            = BitmapPATH

if(MyGlobal.pyjh_version == "3.0"):
    MACHINECHECK_IKEY_TEXT  = "MachineCheck\t\t\t\t\t\t\t\t\t\t(>>iKey<<)"
else:
    MACHINECHECK_IKEY_TEXT  = "MachineCheck                 (>>iKey<<)"

PathTable               = jh.ResPath("TNC:\\PLCDATA\\PYTHON\\UPPERSCREEN_CFG_0.TAB")
PathTableMTYP           = jh.ResPath("PLC:\\PLC_TAB\\UPPER_CFG_All.TAB")
machineCheckConfig      = "machineCheckConfig"
machineCheckLog         = "machineCheckLog"
IKEYS                   = "iKeys"
PLCAddress              = "\\PLC\\program\\symbol\\global\\"
totalUpTimeReg          = "DG_Zeit_Maschine_Ein"
totalProgrammTimeReg    = "DG_Zeit_Auto_Betrieb_run"
SA_ActiveReg            = "MG_Service_Agent_PC_aktiv"
Set_Auto_Betrieb_run    = "DG_Zeit_Set_AutoBetr_run"
Set_Maschine_EIN        = "DG_Zeit_Set_Maschine_EIN"
DG_PIT_Unicat_Nummer    = "DG_PIT_Unicat_Nummer"
LanguageReg             = "BG_MP_7230_1"
MAINTENANCE             = "MAINTENANCE"
INSPECTION              = "INSPECTION"
SMARTKEYTEXT            = "Bitte ID und Passwort eingeben"


MACHINECHECK            = "MachineCheck"
VERSION                 = "1.006.001"
VERSION_FILENAME        = PATH + "dmgversion.txt"
PROGRAM_RUNTIME         = "PROGRAM_RUNTIME"
SERVICE_AGENT_INSTALLED = "SERVICE_AGENT_INSTALLED"
MachineCheckInvalid     = "MachineCheckInvalid"
ENTER_ID_AND_PASSWORD	= "ENTER_ID_AND_PASSWORD"
PLEASE_ENTER_RESET_CODE = "PLEASE_ENTER_RESET_CODE"
NEXT_MAINTENANCE_AFTER  = "NEXT_MAINTENANCE_AFTER"
NEXT_INSPECTION_AFTER   = "NEXT_INSPECTION_AFTER"
RESET_CODE              = 78857676

'--------------------------Die Texte sollen in txt-File abgelegt werden------------------------'
SA_MESSAGE              = "Ihre Wartung wird durch den DMG Service Agent unterstützt!"
'-------------------------XML-TAGS-LogFile-----------------------------------------------------'
ALARM                   = "alarm"
ID                      = "id"
OCCURRENCE              = "occurrence"
DATE                    = "date"
TIME                    = "time"
PGMHOURS                = "pgmhours"
ACKNOWLEDGEMENT         = "acknowledgement"
USER                    = "user"
REASON                  = "reason"
OK                      = "OK"
CANCEL                  = "cancel"
RESET_COUNTER           = "RESET COUNTER"

'-------------------------XML-TAGS-DefinitionFile-----------------------------------------------------'
MESSAGE                 = "message"
COMMENT                 = "comment"
INTERVAL                = "interval"
LEVEL                   = "level"
PAGE                    = "page"
HEAD                    = "head"
BODY                    = "body"

'-------------------------XML-TAGS-KonfigFile-----------------------------------------------------'
lastTotalUpTime         = "lastTotalUpTime"
lastTotalProgramTime    = "lastTotalProgramTime"
SMARTKEY                = "key"
SMARTPW                 = "pw"

'-------------------------XML-TAGS-BaseTechnologieFile-----------------------------------------------------'
DETAILS                 = "Details"
BASIS                   = "BASIS"
MTYP                    = "MTYP"

class DMGMachineCheck:

    m_MachineCheckView              = None
    m_LogFileMessageList            = []
    m_DefinitionFileMessageList     = []


    def readLanguage(self):
        langugeIDs = ['eng', 'deu', 'csy', 'fra', 'ita', 'esp', 'ptp', 'sve', 'dan', 'fin', 'nld', 'plk', 'hun', 'rus', 'chs', 'cht', 'eng','eng', 'eng', 'eng', 'kor', 'eng', 'trk', 'eng']
        LanguagText = None
        if(Simulate == 1):
            LanguagText = "deu"
        else:
            languageID           = com.read(PLCAddress + LanguageReg)
            languageID           = languageID[LanguageReg]
            if(len(languageID) > 0  and int(languageID)  >= 0 and int(languageID) < 24):
                LanguagText = langugeIDs[int(languageID)]
            else:
                LanguagText = "eng"
        return LanguagText

    def readTotalAndProgramTimeFromPLC(self):
        if(Simulate == 1):
            self.totalTimeFromPLC = 0
            TotalProgrammTime   = int(float(self.dmgXMLPasre.getXMLTagValue(lastTotalProgramTime)))
            self.totalProgramTimeFromPLC= int(float(self.totalProgramTimeFromPLC)) + 1

        else:
            result = com.read(PLCAddress + totalUpTimeReg)
            if(result != None):
                result = result[totalUpTimeReg]
                if(len(result) > 0):
                    self.totalTimeFromPLC = int(result)

            result = com.read(PLCAddress + totalProgrammTimeReg)
            if(result != None):
                result = result[totalProgrammTimeReg]
                if(len(result) > 0):
                    self.totalProgramTimeFromPLC = int(result)


    def writeTotalAndProgramTimeToConfigFile(self):
        TotalUpTime         = int(self.dmgXMLPasre.getXMLTagValue(lastTotalUpTime))
        TotalProgrammTime   = int(self.dmgXMLPasre.getXMLTagValue(lastTotalProgramTime))

        if(TotalProgrammTime != None and (TotalProgrammTime > self.totalProgramTimeFromPLC)):
            if(Simulate == 0):
                com.write(PLCAddress + Set_Auto_Betrieb_run, TotalProgrammTime)
                self.totalProgramTimeFromPLC = int(TotalProgrammTime)
        else:
            self.dmgXMLPasre.addTag(machineCheckConfig, lastTotalProgramTime, str(self.totalProgramTimeFromPLC))

        if(TotalUpTime != None and (TotalUpTime > self.totalTimeFromPLC)):
            if(Simulate == 0):
                com.write(PLCAddress + Set_Maschine_EIN, TotalUpTime)
                self.totalTimeFromPLC = int(TotalUpTime)
        else:
            self.dmgXMLPasre.addTag(machineCheckConfig, lastTotalUpTime, str(self.totalTimeFromPLC))


    def readSmartKeyConfig(self):
        size = len(self.m_SmartKeyList)
        for i in range(size):
            self.m_SmartKeyList.remove(self.m_SmartKeyList[0])
        nodeSize = self.dmgXMLPasre.getCountXMLNodes()
        i = 0
        for i in range(nodeSize):
            tagName = self.dmgXMLPasre.getXMLTagName(i)
            if(tagName == SMARTKEY):
                SmartKeyData = DMGMachineCheckSmartKeyData()
                SmartKeyData.m_ID = self.dmgXMLPasre.getAttributValue(i, ID)
                SmartKeyData.m_PW = self.dmgXMLPasre.getAttributValue(i, SMARTPW)
                self.m_SmartKeyList.append(SmartKeyData)

    def readBaseTechnologieFile(self):
        nodeSize = self.dmgXMLBaseTechnologieFile.getCountXMLNodes()
        for i in range(nodeSize):
            tagName = self.dmgXMLBaseTechnologieFile.getXMLTagName(i)
            if(tagName == DETAILS):
                dictBT = {}
                myBasisTechnologie = DMGBasisTechnologie()
                BT = self.dmgXMLBaseTechnologieFile.getAttributValue(i, BASIS)
                mTyp = self.dmgXMLBaseTechnologieFile.getAttributValue(i, MTYP)
                myBasisTechnologie.m_BT = BT
                myBasisTechnologie.m_MTYP = mTyp
                self.m_lstBaseTechnologie.append(myBasisTechnologie)

    def readLogFile(self):
        'Service-Agent Meldung bei ID = -2 anzeigen'
        newEntry = DMGMachineCheckLogFileData()
        newEntry.m_ID = "-2"
        newEntry.m_ShowMessage = False
        newEntry.m_ReminderActive = False
        self.m_LogFileMessageList.append(newEntry)

        'SamrtKey-Fenster bei ID = -1 anzeigen'
        newEntry = DMGMachineCheckLogFileData()
        newEntry.m_ID = "-1"
        newEntry.m_ShowMessage = True
        newEntry.m_ReminderActive = False
        self.m_LogFileMessageList.append(newEntry)

        'Standard-Meldung bei ID = 0 anzeigen'
        newEntry_ = DMGMachineCheckLogFileData()
        newEntry_.m_ID = "0"
        newEntry_.m_ShowMessage = True
        newEntry_.m_ReminderActive = False
        self.m_LogFileMessageList.append(newEntry_)

        dmgLogFileData = None
        nodeSize = self.dmgXMLLogFile.getCountXMLNodes()
        FindAlarmID = False
        for i in range(nodeSize):
            tagName = self.dmgXMLLogFile.getXMLTagName(i)
            if(tagName == ALARM):
                'unbehandelte Meldungen beim Start anzeigen'
                if(dmgLogFileData != None and len(dmgLogFileData.m_Reason) == 0):
                    dmgLogFileData.m_ShowMessage = True
                    dmgLogFileData.m_ReminderActive = True
                elif(dmgLogFileData != None and len(dmgLogFileData.m_Reason) != 0):
                    'behandelte meldung mit OK werden durch Reminder nicht aufgerufen sondern beim nächsten Intervall aufgerufen'
                    dmgLogFileData.m_ReminderActive = False
                    'behandelte meldung mit Cancel werden durch Reminder aufgerufen'
                    dmgLogFileData.m_ShowMessage = False
                if(dmgLogFileData != None):
                    self.m_LogFileMessageList.append(dmgLogFileData)

                dmgLogFileData                              = DMGMachineCheckLogFileData()
                dmgLogFileData.m_ID                         = self.dmgXMLLogFile.getAttributValue(i, ID)

            if(tagName == OCCURRENCE):
                dmgLogFileData.m_Occurrence.m_Date          = self.dmgXMLLogFile.getAttributValue(i, DATE)
                dmgLogFileData.m_Occurrence.m_Time          = self.dmgXMLLogFile.getAttributValue(i, TIME)
                dmgLogFileData.m_Occurrence.m_pgmHours      = self.dmgXMLLogFile.getAttributValue(i, PGMHOURS)
                'Hier wird festgelegt, Wann die Meldung auftreten soll'
                dmgLogFileData.m_LastTime = dmgLogFileData.m_Occurrence.m_pgmHours
                'unbehandelte Meldungen nicht mehr aktualisieren'
                dmgLogFileData.m_Reason = ""
            if(tagName == ACKNOWLEDGEMENT):
                dmgLogFileData.m_Acknowledgement.m_Date     = self.dmgXMLLogFile.getAttributValue(i, DATE)
                dmgLogFileData.m_Acknowledgement.m_Time     = self.dmgXMLLogFile.getAttributValue(i, TIME)
                dmgLogFileData.m_Acknowledgement.m_pgmHours = self.dmgXMLLogFile.getAttributValue(i, PGMHOURS)
                'Hier wird festgelegt, Wann die Meldung auftreten soll'
                dmgLogFileData.m_LastTime = dmgLogFileData.m_Acknowledgement.m_pgmHours
            if(tagName == USER):
                dmgLogFileData.m_User                       = self.dmgXMLLogFile.getXMLTagValue(USER, i)
            if(tagName == REASON):
                dmgLogFileData.m_Reason                     = self.dmgXMLLogFile.getXMLTagValue(REASON, i)

        if(dmgLogFileData != None and len(dmgLogFileData.m_Reason) == 0):
            dmgLogFileData.m_ShowMessage = True
            dmgLogFileData.m_ReminderActive = True
        elif(dmgLogFileData != None and len(dmgLogFileData.m_Reason) != 0):
            dmgLogFileData.m_ShowMessage = False
            dmgLogFileData.m_ReminderActive = False
        if(dmgLogFileData != None):
            self.m_LogFileMessageList.append(dmgLogFileData)

    def getXMLDataFromDefinitionFile(self, fileHandle):
        fileHandle.seek(0)
        counter = 0x77777777
        txt = ""
        while (1):
            line = fileHandle.read(4)
            if(line == ""):
                break
            if(len(line) == 4):
                data = unpack('i', line)[0]
                c = int(data) ^ counter
                data = pack('i', c)
                txt+=data
                counter-=1
        fileHandle.close()
        if(len(txt) > 0):
            return txt
        else:
            return None

    def readDataFromDefinitionFile(self, xmlData):
        dmgMessageData      = None
        myDMGMessagesPage   = None
        foundPagTag         = False
        self.dmgXMLDefnitionFile.parseString(xmlData)
        nodeSize = self.dmgXMLDefnitionFile.getCountXMLNodes()
        FindMessage = False
        for i in range(nodeSize):
            tagName = self.dmgXMLDefnitionFile.getXMLTagName(i)
            if(tagName == COMMENT):
                self.m_Comment   =   self.dmgXMLDefnitionFile.getXMLTagValue(COMMENT, i)
                self.m_Comment = string.replace(self.m_Comment, "font", "span")
                self.m_Comment = string.replace(self.m_Comment, "\n", "")
                self.m_Comment = string.replace(self.m_Comment, "   ", "")
                self.m_MachineCheckView.setCommentLabelText(self.m_Comment)

            if(tagName == MESSAGE):
                if(myDMGMessagesPage != None and (myDMGMessagesPage.m_Head != None or myDMGMessagesPage.m_Body != None)):
                    dmgMessageData.m_DefinitionFileMessages.append(myDMGMessagesPage)
                    myDMGMessagesPage   = None
                    foundPagTag         = False
                if(dmgMessageData != None):
                    self.m_DefinitionFileMessageList.append(dmgMessageData)
                    dmgMessageData      = None

                dmgMessageData                  = DMGMachineCheckMessagesData()
                dmgMessageData.m_ID             = self.dmgXMLDefnitionFile.getAttributValue(i, ID)
                dmgMessageData.m_Interval       = self.dmgXMLDefnitionFile.getAttributValue(i, INTERVAL)
                dmgMessageData.m_Level          = self.dmgXMLDefnitionFile.getAttributValue(i, LEVEL)
            if(tagName == PAGE):
                foundPagTag = True
                if(myDMGMessagesPage != None and (myDMGMessagesPage.m_Head != None or myDMGMessagesPage.m_Body != None)):
                    dmgMessageData.m_DefinitionFileMessages.append(myDMGMessagesPage)
                myDMGMessagesPage               = DMGMessagesPage()
            if(tagName == HEAD and foundPagTag and myDMGMessagesPage != None):
                myDMGMessagesPage.m_Head        =   self.dmgXMLDefnitionFile.getXMLTagValue(HEAD, i)
            if(tagName == BODY and foundPagTag and myDMGMessagesPage != None):
                myDMGMessagesPage.m_Body        =   self.dmgXMLDefnitionFile.getXMLTagValue(BODY, i)

        if(myDMGMessagesPage != None and (myDMGMessagesPage.m_Head != None or myDMGMessagesPage.m_Body != None)):
            dmgMessageData.m_DefinitionFileMessages.append(myDMGMessagesPage)
        if(dmgMessageData != None):
            self.m_DefinitionFileMessageList.append(dmgMessageData)

    def createNewAttrListForAppearanceMessage(self, MessageID):
        'PGM-Hours ermitteln'
        if(Simulate == 1 or SUMULATE_ITNC == 1):
            self.pgmHous =  (self.totalProgramTimeFromPLC)
        else:
            self.pgmHous =  int(self.totalProgramTimeFromPLC/3600)

        'Datum ermitteln'
        self.appearanceDate = time.strftime("%Y/%m/%d",time.gmtime())
        self.appearanceTime = time.strftime("%H:%M:%S",time.localtime())

        listAttr = []
        dictAttr = {}

        dictAttr['Name'] = DATE
        dictAttr['Value'] = self.appearanceDate
        listAttr.append(dictAttr)

        dictAttr = {}
        dictAttr['Name'] = TIME
        dictAttr['Value'] = self.appearanceTime
        listAttr.append(dictAttr)

        dictAttr = {}
        dictAttr['Name'] = PGMHOURS
        dictAttr['Value'] = str(self.pgmHous)
        listAttr.append(dictAttr)
        return listAttr

    def getNewMessageLogDate(self, MessageID, level=None):
        'Wartung in LogFileMessageList schreiben'
        logFileData = DMGMachineCheckLogFileData()
        logFileData.m_ID                    = MessageID
        logFileData.m_Occurrence.m_Date     = self.appearanceDate
        logFileData.m_Occurrence.m_Time     = self.appearanceTime
        logFileData.m_Occurrence.m_pgmHours = str(self.pgmHous)
        logFileData.m_Level                 = level
        return logFileData

    def getMessageDiscription(self, messageID, pageNumber=0):
        head_ = None
        body_ = None
        page_ = 0
        level_ = None
        self.m_Level =  0
        self.m_PicturCode = BLUE_STATIC
        result = False

        sizeMessageData = len(self.m_DefinitionFileMessageList)
        for i in range(sizeMessageData):
            message = self.m_DefinitionFileMessageList[i]
            if(messageID != None and (int(message.m_ID) == int(messageID))):
                sizePages = len(message.m_DefinitionFileMessages)
                if(pageNumber < sizePages):
                    result = True
                    self.m_Page = pageNumber
                    body_ = message.m_DefinitionFileMessages[pageNumber].m_Body
                    head_ = message.m_DefinitionFileMessages[pageNumber].m_Head

                    if(message.m_Level == MAINTENANCE):
                        self.m_Level =  1
                        self.m_PicturCode = YELLOW_STATIC
                    elif(message.m_Level == INSPECTION):
                        self.m_Level =  2
                        self.m_PicturCode = ORANGE_STATIC
                else:
                    self.m_Page = pageNumber - 1
                break
        if(result):
            sizeLogDatei = len(self.m_LogFileMessageList)
            for i in range (sizeLogDatei):
                logMessage = self.m_LogFileMessageList[i]
                if(int(logMessage.m_ID) == int(messageID)):
                    logMessage.m_PageNumber = pageNumber
                    self.m_LogFileMessageList[i] = logMessage
                    break

        return (head_, body_, self.m_Page)

    def getMessageLevel(self):
        typeMessage = None
        appearenceCounter = 0
        pageNumber = 0
        self.m_AppearenceTime = None
        self.m_AppearenceTime = None
        sizeLogDatei = len(self.m_LogFileMessageList)
        for i in range (sizeLogDatei):
            logMessage = self.m_LogFileMessageList[i]
            if(logMessage.m_ShowMessage and (int(logMessage.m_ID) == int(self.m_MessageID))):
                typeMessage           = logMessage.m_Level
                appearenceCounter     = logMessage.m_AppearanceCounter
                pageNumber            = logMessage.m_PageNumber
                self.m_AppearenceTime = logMessage.m_Occurrence.m_Date + " " + logMessage.m_Occurrence.m_Time
                if(len(logMessage.m_Occurrence.m_pgmHours) > 0 ):
                    if(SUMULATE_ITNC == 1):
                        self.m_AppearencePgm  = self.PGMTIMETEXT + logMessage.m_Occurrence.m_pgmHours + " s "
                    else:
                        self.m_AppearencePgm  = self.PGMTIMETEXT + logMessage.m_Occurrence.m_pgmHours + " h "
                else:
                    self.m_AppearencePgm = ""
                break
        return (typeMessage, appearenceCounter, pageNumber)

    def isServiceAgentConnected(self):
        result = False
        if(Simulate == 0):
            SAConnected_ = com.read(PLCAddress + SA_ActiveReg)
            SAConnected_ = SAConnected_[SA_ActiveReg]
            if(len(SAConnected_) > 0):
                if(SAConnected_ != None and SAConnected_ != "0"):
                   result = True
        return result

    def updateReminder(self, level, reminderInterval):
        result = False
        sizeLogDatei = len(self.m_LogFileMessageList)
        x = 0
        for x in range(sizeLogDatei):
            logMessage = self.m_LogFileMessageList[x]
            self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(int(logMessage.m_ID))
            reminderValue = reminderInterval + int(float(logMessage.m_LastTime))
            'Updatereminder wird erreicht, wenn die Wartung bzw Inspektion sichtbar ist und Reminderintervall < Programmlaufzeit'
            if(int(self.m_Level) == int(level) and (reminderValue < self.totalProgramTimeFromPLC) and logMessage.m_ReminderActive and logMessage.m_ShowMessage):
                logMessage.m_Level = int(level)
                logMessage.m_AppearanceCounter+= 1
                self.m_LogFileMessageList[x] = logMessage
                if(not self.occurenceInspektionMessage or((int(logMessage.m_ID)== self.m_MessageID))):
                    self.m_MessageID = logMessage.m_ID
                    appearenceTime = logMessage.m_Occurrence.m_Date + " " + logMessage.m_Occurrence.m_Time
                    self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, appearenceTime,  self.PGMTIMETEXT + logMessage.m_Occurrence.m_pgmHours +  " ", self.m_PicturCode, self.m_Level)

                msg = DMGMachineCheckLogFileData()
                msg.m_ShowMessage = False
                self.m_LogFileMessageList[2] = msg

    def hideAllMessages(self, hide=False):

        if(not hide):
            self.m_MessageID = -2
        else:
            self.m_MessageID = self.dumyMsgId
        sizeLogDatei = len(self.m_LogFileMessageList)
        for i in range(sizeLogDatei):
            message = self.m_LogFileMessageList[i]
            if(int(message.m_ID) == -2):
                if(not hide):
                    message.m_ShowMessage = True
                else:
                    message.m_ShowMessage = False
            elif(int(message.m_ID) == -1):
                message.m_ShowMessage = True
            elif(message.m_Reason == "" and True == hide):
                Msg = DMGMachineCheckLogFileData()
                Msg.m_ShowMessage = False
                self.m_LogFileMessageList[2] = Msg
                message.m_ShowMessage = hide
            elif(False == hide):
                message.m_ShowMessage = hide

            self.m_LogFileMessageList[i] = message

    def onTimerEvent(self):

        self.Head = None
        self.Body = None

        if(self.resetCounterActive):
            self.Minute = 0
        if(self.isServiceAgentConnected() and not self.SAAvailable):
            self.dumyMsgId = self.m_MessageID - 1
            self.hideAllMessages()
            txt = self.getText(SERVICE_AGENT_INSTALLED)
            'SA Meldung im Fenster anzeigen'
            self.m_MachineCheckView.showMessage(None, txt, None, None, BLUE_STATIC, 0)
            self.SAAvailable = True
            return True
        if(not self.isServiceAgentConnected() and self.SAAvailable):
            self.SAAvailable = False
            self.hideAllMessages(True)
            self.showNextMessage()

        if((self.isServiceAgentConnected() and self.SAAvailable )):
            return True

        'und Nicht mehr tun, SN-Meldung ausgeben'
        if(self.counter >= self.Minute):
            strText = self.MaintenanceText + ": " + "0" + unit
            self.m_MachineCheckView.showNextTimeMaintenanceAfter(strText)

            strText = self.InspektionText + ": " + str(0) + unit
            self.m_MachineCheckView.showNextTimeInspektionAfter(strText)
            self.counter = 0
            'Maschineeinschalt und gesamtprogramlaufzeit ermitteln'
            self.readTotalAndProgramTimeFromPLC()
            'die Werte in Konfig-Datei schrieben'
            self.writeTotalAndProgramTimeToConfigFile()
            'Ist ein Wartungsinterval oder Inspektionsinterval aufgetreten'
            sizeMessageData = len(self.m_DefinitionFileMessageList)

            afterTimeMessageID = 0
            valueNextTime = 0
            strValue = ""
            for i in range(sizeMessageData):
                message = self.m_DefinitionFileMessageList[i]
                if(Simulate == 1 or SUMULATE_ITNC == 1):
                    self.WartungReminder = 20
                    self.InspektionReminder = 30
                    interval = int(message.m_Interval) /10
                else:
                    interval = int(message.m_Interval) * 3600

                lastTime = interval
                foundAlarmID = False

                sizeLogDatei = len(self.m_LogFileMessageList)
                logMessage = None
                for x in range(sizeLogDatei):
                    logMessage = self.m_LogFileMessageList[x]
                    if(int(logMessage.m_ID) == int(message.m_ID) and int(message.m_ID) > 0 ):
                       foundAlarmID = True
                       if(Simulate == 1  and int(float(logMessage.m_LastTime)) > 0 or (SUMULATE_ITNC == 1 and int(float(logMessage.m_LastTime)) > 0 )):
                           lastTime = int(float(logMessage.m_LastTime)) + interval
                       elif(logMessage.m_LastTime > 0):
                           lastTime = int(float(logMessage.m_LastTime)) * 3600 + interval
                       break

                'Hier wird die After Time (Wartung/Inspektion) berechnet und angezeigt'
                if((lastTime > self.totalProgramTimeFromPLC and foundAlarmID == False)or (lastTime > self.totalProgramTimeFromPLC and not logMessage.m_ShowMessage)):
                   'Hier wird die niedrige bzw die nächste Wartungsintervall berechnet und angezeigt'
                   if(message.m_Level == MAINTENANCE):

                       if(self.m_NextMaintenance == 0 or lastTime < self.m_NextMaintenance ):

                           self.afterTimeMessageID = message.m_ID
                           self.m_NextMaintenance = lastTime

                       if(((self.afterTimeMessageID == message.m_ID) and foundAlarmID == False) or
                          ((self.afterTimeMessageID == message.m_ID) and not logMessage.m_ShowMessage)):

                           value = lastTime - self.totalProgramTimeFromPLC
                           strValue = self.MaintenanceText + ": "  + str(value) + unit

                           if(Simulate == 0 and SUMULATE_ITNC == 0):
                               hour = (int) ((value) / float(3600.0))
                               minute = ((int)(float(value)) /(int)(60.0)) - (int)(hour * 60)
                               strValue = self.MaintenanceText + ":" + str(hour) + "," + str(minute) + unit

                           self.m_MachineCheckView.showNextTimeMaintenanceAfter(strValue)

                   'ist die Meldung eine Inspektion'
                   if(((message.m_Level == INSPECTION and foundAlarmID == False) or ((message.m_Level == INSPECTION) and (not logMessage.m_ShowMessage)))):
                       value = lastTime - self.totalProgramTimeFromPLC
                       strValue = self.InspektionText + ": " + str(value) + unit
                       if(Simulate == 0 and SUMULATE_ITNC == 0):
                           hour = (int) ((value) / float(3600.0))
                           minute = ((int)(float(value)) /(int)(60.0)) - (int)(hour * 60)
                           strValue = self.InspektionText + ":" + str(hour) + "," + str(minute) + unit
                       self.m_MachineCheckView.showNextTimeInspektionAfter(strValue)

                if((int(lastTime) <= int(self.totalProgramTimeFromPLC)) and (int(message.m_ID) > 0 )):

                    attrList = self.createNewAttrListForAppearanceMessage(message.m_ID)
                    newMessageLogFile = self.getNewMessageLogDate(message.m_ID, message.m_Level)
                    standardDisplayMessage = self.m_LogFileMessageList[2]
                    if(standardDisplayMessage.m_ShowMessage):
                        Msg = DMGMachineCheckLogFileData()
                        Msg.m_ShowMessage = False
                        self.m_LogFileMessageList[2] = Msg

                    if(message.m_Level == MAINTENANCE):
                        self.m_Level =  1
                    elif(message.m_Level == INSPECTION):
                        self.m_Level =  2

                    newMessageLogFile.m_ShowMessage = True
                    newMessageLogFile.m_Level = self.m_Level
                    newMessageLogFile.m_ReminderActive = True
                    newMessageLogFile.m_Occurrence.m_pgmHours = str(self.pgmHous)
                    newMessageLogFile.m_LastTime = int(newMessageLogFile.m_Occurrence.m_pgmHours)
                    showMessage = False
                    if(foundAlarmID):
                        'Hier erscheinen die behandelten wartungen, wenn keine Inspektionen vorhanden sind'
                        if(len(logMessage.m_Reason) > 0 and not logMessage.m_ReminderActive):
                            self.m_NextMaintenance = 0
                            node = self.dmgXMLLogFile.getNode(ALARM, message.m_ID)
                            if(node != None):
                                self.dmgXMLLogFile.addAttribut(node, OCCURRENCE, attrList)
                            'Wenn Keine Insoektionsmelung vorhanden ist, dann soll Wartung angezeigt werden.'
                            'Wenn Inspektion vorhanden ist oder sichtbar ist, dann sollen die Wartungen nur beim Blättern angezeigt werden und reminder nur beim Blättern angezeigt werden.'
                            if(not logMessage.m_ShowMessage):
                                showMessage = True

                            logMessage.m_ShowMessage = True
                            logMessage.m_ReminderActive = True
                            logMessage.m_Occurrence.m_pgmHours = str(self.pgmHous)
                            logMessage.m_Occurrence.m_Date     = self.appearanceDate
                            logMessage.m_Occurrence.m_Time     = self.appearanceTime
                            logMessage.m_Level = self.m_Level
                            logMessage.m_Reason=""
                            logMessage.m_LastTime = int(self.pgmHous)
                            self.m_LogFileMessageList[x] = logMessage

                    else:
                        self.m_NextMaintenance = 0
                        'Hier erscheinen neuen Meldungen, die in Logdatei noch nicht vorhanden sind und neu aufgetreten sind'
                        showMessage = True
                        self.m_LogFileMessageList.append(newMessageLogFile)
                        listAttr = []
                        dictAttr = {}
                        dictAttr['Name'] = ID
                        dictAttr['Value'] = message.m_ID
                        listAttr.append(dictAttr)
                        node = self.dmgXMLLogFile.getNode(machineCheckLog)
                        if(node != None):
                            self.dmgXMLLogFile.addAttribut(node, ALARM, listAttr)
                        node = self.dmgXMLLogFile.getNode(ALARM, message.m_ID)
                        if(node != None):
                            self.dmgXMLLogFile.addAttribut(node, OCCURRENCE, attrList)

                    'Wird eine Inspektionsmeldung angezeigt, dann sollen alle Wartungen außer der Inspektionsmeldung ausgeblendet werden'
                    if(message.m_Level == INSPECTION):
                        self.occurenceInspektionMessage = True
                        strText = self.InspektionText + ": " + str(0) + unit
                        self.m_MachineCheckView.showNextTimeInspektionAfter(strText)

                    if(showMessage):
                        self.m_MessageID = int (message.m_ID)
                        self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(message.m_ID)
                        self.m_AppearenceTime = self.appearanceDate + " " + self.appearanceTime
                        if( SUMULATE_ITNC == 1):
                            self.m_AppearencePgm  = self.PGMTIMETEXT + str(self.pgmHous) + " s "
                        else:
                            self.m_AppearencePgm  = self.PGMTIMETEXT + str(self.pgmHous) + " h "

                        self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, self.m_AppearenceTime, self.m_AppearencePgm, self.m_PicturCode, self.m_Level)


        'Hier erscheinen Wartungen Meldungen, die in Logdatei vorhanden sind und mit CANCEL behandet sind'
        if(self.ReminderMaintenanceCounter >= self.WartungReminder):
            self.ReminderMaintenanceCounter = 0
            self.updateReminder(1, self.WartungReminder)
        'Hier erscheinen Inspektionen Meldungen, die in Logdatei vorhanden sind und mit CANCEL behandet sind'
        if(self.ReminderInspektionCounter >= self.InspektionReminder):
            self.ReminderInspektionCounter = 0
            self.updateReminder(2, self.InspektionReminder)

        'die Wartungen werden sekundlich geblinkt, wenn die gerade angezeigte Meldung ein Wartungsmeldung ist'
        actMessageLevel, appearencCounter, pageNumber = self.getMessageLevel()
        if(actMessageLevel != None and actMessageLevel == 1):
            if(appearencCounter >= 1 ):
                self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(int(self.m_MessageID), pageNumber)
                if(self.PicturCodeMaintenance):
                    self.m_PicturCode = YELLOW_BLINK
                    self.PicturCodeMaintenance = False
                else:
                    self.m_PicturCode = YELLOW_STATIC
                    self.PicturCodeMaintenance = True

                self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, self.m_AppearenceTime , self.m_AppearencePgm, self.m_PicturCode, self.m_Level)
        elif(actMessageLevel != None):
            if(appearencCounter == 1 ):
                self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(int(self.m_MessageID), pageNumber)
                if(self.PicturCodeInspektionOrangeStatic):
                     self.m_PicturCode = ORANGE_BLINK
                     self.PicturCodeInspektionOrangeStatic = False
                else:
                   self.m_PicturCode = ORANGE_STATIC
                   self.PicturCodeInspektionOrangeStatic = True
                self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, self.m_AppearenceTime, self.m_AppearencePgm, self.m_PicturCode, self.m_Level)
            elif(appearencCounter >= 2 ):
                self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(int(self.m_MessageID), pageNumber)
                if(self.PicturCodeInspektionRedStatic):
                    self.m_PicturCode = RED_BLINK
                    self.PicturCodeInspektionRedStatic = False
                else:
                    self.m_PicturCode = RED_STATIC
                    self.PicturCodeInspektionRedStatic = True
                self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, self.m_AppearenceTime, self.m_AppearencePgm, self.m_PicturCode, self.m_Level)

        self.counter+=1
        self.ReminderMaintenanceCounter+=1
        self.ReminderInspektionCounter+=1
        if(self.resetCounterActive):
            self.resetCounterActive = False
            if(Simulate == 0 and SUMULATE_ITNC == 0):
                self.Minute = 60

        return True
    def setInspektionKey(self, ID, PW):
        result = False
        ID = int(ID)
        myID = ID
        listAttr = []
        dictAttr = {}

        dictAttr['Name'] = "id"
        dictAttr['Value'] = str(ID)
        listAttr.append(dictAttr)

        dictAttr = {}

        dictAttr['Name'] = SMARTPW
        dictAttr['Value'] = str(PW)
        listAttr.append(dictAttr)

        #pwInternal = (ID ^(((ID%7)+1)*0x06000000-1))+100000000
        #if(pwInternal == int(PW) and (pwInternal > 100000000 or pwInternal < 999999999)):
        self.calculateiKey()
        if( int(PW) == int(self.m_iKeyPw) ):
            result = True
            'ID und PW in Konfigdatei schreiben'
            node = self.dmgXMLPasre.getNode(IKEYS)
            'sichern stelle, ob SmartID in Konfig vorhanden ist'
            foundID = False

            size = len(self.m_SmartKeyList)
            for i in range(size):
                SmartKeyData = self.m_SmartKeyList[i]
                if(SmartKeyData.m_ID != None and (int(SmartKeyData.m_ID) == int (myID))):
                    foundID = True
                    break
            if(foundID):
                nodeLast, nodeNext = self.dmgXMLPasre.getLastAndNextNode(SMARTKEY, None, str(myID))
                self.dmgXMLPasre.repleaseAttribut(node, nodeLast,SMARTKEY, listAttr)
            else:
                self.dmgXMLPasre.addAttribut(node, SMARTKEY,listAttr)
            self.readSmartKeyConfig()
        return result

    def getIDAndPW(self):
        SmartID = None
        SmartPw = None
        result, pw = self.isInspektionKeyValid()
        if(result and pw!=None and self.smartKeyID > 0):
            SmartID = self.smartKeyID
            SmartPw = pw
        elif(result and pw==13 and self.smartKeyID > 0):
            'ServiceKey'
            SmartID = self.smartKeyID
            SmartPw = pw
        elif(self.smartKeyID > 0 and ((self.smartKeyID > 10000000) or (self.smartKeyID < 139999999))):
            SmartID = self.smartKeyID
        else:
            size = len(self.m_SmartKeyList) - 1
            if(size >= 0):
                SmartKeyData = self.m_SmartKeyList[size]
                SmartID = SmartKeyData.m_ID
        return(SmartID, SmartPw)

    def isInspektionKeyValid(self):
        result = False
        pw = None
        'aus Kofig.Datei die eingetragene Password und die zugehörige ID ermitteln'
        size = len(self.m_SmartKeyList)
        for i in range(size):
            SmartKeyData = self.m_SmartKeyList[i]
            if(int(SmartKeyData.m_ID) == self.smartKeyID):
                self.calculateiKey()
                pw = SmartKeyData.m_PW
                if( int(pw) == int (self.m_iKeyPw) ):
                    result = True
                break

        if(not result):
            skey = str(self.smartKeyID)
            index1 = int(string.find(skey, "1", 0))
            index2 = int(string.find(skey, "3", 0))

            if(SUMULATE_ITNC == 0 and Simulate == 0):
                value = (self.smartKeyID ^(((self.smartKeyID%7)+1)*0x06000000-1))+100000000
                if((value > 100000000 or value < 999999999)):

                    if(index1 == 0 and index2 == 1):
                        result = True
                        pw = 13
                    else:
                        pw = value
            else:
                if(index1 == 0 and index2 == 1):
                    result = True
                    pw = 13

        return (result, pw)

    def calculateiKey(self):
        if(self.m_BTIndex > 0 and self.smartKeyID > 0):
            value1 = (self.smartKeyID ^(((self.smartKeyID%7)+1)*0x06000000-1))+100000000
            value2 = (65535 ^( self.m_BTIndex*(((self.m_BTIndex%7)+1) + 1000))) * 10000000
            self.m_iKeyPw = value1 + value2
        else:
            self.m_iKeyPw = 0


    def CallBackSmartKeyID(self, dict):
      if dict != None:
          strText = dict[DG_PIT_Unicat_Nummer]
          if(len(strText) > 0 and int(strText) > 0):
              self.m_SmartKeyActive = True
              self.smartKeyID = int(strText)
              self.m_MachineCheckView.updateStateOkButton()

    def CallBackKeySwitchID(self, dict):
      if dict != None:
          strText = dict["BG_AKTIVE_BA"]
          if(len(strText) > 0):
              if(int(strText) == 5 and not self.m_SmartKeyActive):
                  self.smartKeyID = 130000161
                  self.m_MachineCheckView.updateStateOkButton()
              elif(int(strText) != 5 and not self.m_SmartKeyActive):
                  self.smartKeyID = 0
                  self.m_MachineCheckView.updateStateOkButton()

    def isShowMessage(self):
        result = False
        sizeLogDatei = len(self.m_LogFileMessageList)
        for x in range(sizeLogDatei):
            logMessage = self.m_LogFileMessageList[x]
            if(int(logMessage.m_ID) == int(self.m_MessageID)):
                if(logMessage.m_ShowMessage):
                    result = True
                    break
        if(sizeLogDatei > 0):
            return result
        else:
            return None

    def getNextMessageIDNumber(self):
        result = False
        sizeLogDatei = len(self.m_LogFileMessageList)
        for x in range(sizeLogDatei):
            logMessage = self.m_LogFileMessageList[x]
            if(int(logMessage.m_ID) == self.m_MessageID):
                z = x + 1
                if( z < sizeLogDatei):
                    logMessage_ = self.m_LogFileMessageList[z]
                    self.m_MessageID = int(logMessage_.m_ID)
                    result = True
                break
        return result

    def showNextMessage(self):
        while(1):
            actMessageLevel, appearencCounter, pageNumber = self.getMessageLevel()
            self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(int(self.m_MessageID), pageNumber + 1)
            pageHead = self.m_Head
            pageBody = self.m_Body
            result = self.isShowMessage()
            'Hier wird die nächste Seite(Page) angezeigt'
            if(result and (pageHead != None or pageBody != None)):
                self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, self.m_AppearenceTime, self.m_AppearencePgm, self.m_PicturCode, self.m_Level)
                break
            if(not self.getNextMessageIDNumber()):
                 self.m_MessageID =-2

            sizeLogDatei = len(self.m_LogFileMessageList)
            x = 0
            for x in range(sizeLogDatei):
                logMessage = self.m_LogFileMessageList[x]
                if(int(logMessage.m_ID) == self.m_MessageID and int(logMessage.m_ID) == -1):
                    foundID = True
                    keyID = None
                    keyPW = None
                    size = len(self.m_SmartKeyList)
                    for i in range(size):
                        SmartKeyData = self.m_SmartKeyList[i]
                        if(SmartKeyData.m_ID != None and (int(SmartKeyData.m_ID) == self.smartKeyID)):
                            keyID =  self.smartKeyID
                            keyPW =  int (SmartKeyData.m_PW)
                    'wenn kein Smartkey angelegt ist, dann die beiden Eingabenfeldern leer ausgeben'
                    self.m_MachineCheckView.showSmartKeyWindow(keyID, keyPW, -1)
                    return
                elif(int(logMessage.m_ID) == 0 and self.m_MessageID == int(logMessage.m_ID) and logMessage.m_ShowMessage):

                    self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(int(self.m_MessageID))
                    self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, None, None, self.m_PicturCode, self.m_Level)
                    return
                elif(int(logMessage.m_ID) == 0 and self.m_MessageID ==  int(logMessage.m_ID) and not logMessage.m_ShowMessage):
                    self.m_MessageID = 0
                elif(int(logMessage.m_ID) == -2 and self.m_MessageID == int(logMessage.m_ID) and logMessage.m_ShowMessage):
                    txt = self.getText(SERVICE_AGENT_INSTALLED)
                    self.m_MachineCheckView.showMessage(None, txt, None, None, BLUE_STATIC, 0)
                    return
                elif(int(logMessage.m_ID) == -2 and self.m_MessageID == int(logMessage.m_ID) and not logMessage.m_ShowMessage):
                    self.m_MessageID =-2
                elif(int(logMessage.m_ID) == self.m_MessageID and int(logMessage.m_ID) > 0):

                    if(logMessage.m_ShowMessage):
                        self.getMessageLevel()
                        self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(int(self.m_MessageID))
                        self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, self.m_AppearenceTime, self.m_AppearencePgm, self.m_PicturCode, self.m_Level)
                        return

    def startTimer(self):
        self.m_NextMaintenance = 0
        self.resetCounterActive = True
        self.TimerID = gobject.timeout_add(1000, self.onTimerEvent)

    def setAcknowledgMessage(self,messageID=None, reason=None, attrList=None):
        'Hier werden die behandelten Meldungen in ogdatei geschrieben'
        node = self.dmgXMLLogFile.getNode(ALARM, messageID)
        if(node != None):
            self.dmgXMLLogFile.addAttribut(node, ACKNOWLEDGEMENT, attrList)

        lastNode, nextNode = self.dmgXMLLogFile.getLastAndNextNode(ALARM, ACKNOWLEDGEMENT, messageID)
        if(nextNode != None):
            self.dmgXMLLogFile.appendNewTag(nextNode,USER, self.smartKeyID)

            lastNode, acknowledgNode = self.dmgXMLLogFile.getLastAndNextNode(ALARM, ACKNOWLEDGEMENT, messageID)
            if(not reason and acknowledgNode != None):
                self.dmgXMLLogFile.appendNewTag(acknowledgNode,REASON, CANCEL)
            elif(reason != None):
                self.dmgXMLLogFile.appendNewTag(acknowledgNode,REASON, OK)


    def ignorMessage(self, acknowledge=False):
        'Stop Timer'
        if(self.TimerID != 0):
            gobject.source_remove(self.TimerID)
            del self.TimerID
        'Hier wird die AfterWartungsintervalle wieder zurückgesetzt'
        self.m_NextMaintenance = 0
        attrList = self.createNewAttrListForAppearanceMessage(self.m_MessageID)
        sizeLogDatei = len(self.m_LogFileMessageList)
        level = 0

        self.readTotalAndProgramTimeFromPLC()
        self.pgmHous =  int(self.totalProgramTimeFromPLC/3600)
        for i in range(sizeLogDatei):
            HeigPriorityMessage = self.m_LogFileMessageList[i]
            if(int(HeigPriorityMessage.m_ID) == int(self.m_MessageID)):
                'behandelte meldung wird beim näcshten Intervall wieder angezeigt und ausgebelndet'
                HeigPriorityMessage.m_LastTime = int(self.pgmHous)
                HeigPriorityMessage.m_ShowMessage = False
                'behandelte Meldung mit OK wird nicht mehr geblinkt und durch Reminder nicht mehr aufgerufen'
                HeigPriorityMessage.m_AppearanceCounter = 0
                HeigPriorityMessage.m_ReminderActive = False
                if(HeigPriorityMessage.m_Level == 2):
                    level = HeigPriorityMessage.m_Level

                if(acknowledge):
                    HeigPriorityMessage.m_Reason = OK
                    HeigPriorityMessage.m_Occurrence.m_Date     = self.appearanceDate
                    HeigPriorityMessage.m_Occurrence.m_Time     = self.appearanceTime
                    HeigPriorityMessage.m_Occurrence.m_pgmHours = str(self.pgmHous)
                else:
                    'behandelte Meldung mit CANCEL wird durch Reminder noch mal aufgetreten'
                    HeigPriorityMessage.m_Reason = CANCEL
                    self.m_showReminder = False
                    self.m_LogFileMessageList[i] = HeigPriorityMessage
                break
        'Hier werden die behandelten Meldungen in ogdatei geschrieben'
        node = self.dmgXMLLogFile.getNode(ALARM, self.m_MessageID)
        if(node != None):
            self.dmgXMLLogFile.addAttribut(node, ACKNOWLEDGEMENT, attrList)

        lastNode, nextNode = self.dmgXMLLogFile.getLastAndNextNode(ALARM, ACKNOWLEDGEMENT, self.m_MessageID)
        if(nextNode != None):
            self.dmgXMLLogFile.appendNewTag(nextNode,USER, self.smartKeyID)

            lastNode, acknowledgNode = self.dmgXMLLogFile.getLastAndNextNode(ALARM, ACKNOWLEDGEMENT, self.m_MessageID)
            if(not acknowledge and acknowledgNode != None):
                self.dmgXMLLogFile.appendNewTag(acknowledgNode,REASON, CANCEL)
            elif(acknowledgNode != None):
                self.dmgXMLLogFile.appendNewTag(acknowledgNode,REASON, OK)

        sizeLogDatei = len(self.m_LogFileMessageList)
        result = False
        self.occurenceInspektionMessage = False

        'Hier wird beim Ausblenden einer meldung die nächst vorhandene meldung angezeigt'
        for i in range(sizeLogDatei):
            HeigPriorityMessage = self.m_LogFileMessageList[i]
            if(int(HeigPriorityMessage.m_ID) > 0 and HeigPriorityMessage.m_ShowMessage):
                result = True
                break
        if(not result):
            HeigPriorityMessage = self.m_LogFileMessageList[2]
            HeigPriorityMessage.m_ShowMessage = True
            self.m_LogFileMessageList[2] = HeigPriorityMessage
            'standardmeldung anzeigen'
            self.m_MessageID = -1

    def getText(self, Key):
        size = len(self.m_LngTextList)
        txt = None
        for i in range(size):
            dictText = self.m_LngTextList[i]
            strKey   = dictText['Key']
            strValue = dictText['Value']
            if(strKey.strip() == Key):
                txt = strValue
                break
        if(txt == None):
            txt = Key
        return txt
    'Alle unbehandelte Wartungen beim ersten Start nicht mehr anzeigen'
    def hideAllUnQuitMaintenaceMessages(self):
        result = False
        inspektionMessageID  = 0
        'Wird eine unbehandelte Inspektionsmeldung gefunden, dann sollen beim Start keine Wartungen angezeigt werden, sondern nur eine Inspektionsmeldung'
        sizeMessageData = len(self.m_DefinitionFileMessageList)
        for i in range(sizeMessageData):
            message = self.m_DefinitionFileMessageList[i]
            if(message.m_Level == INSPECTION):
                size = len(self.m_LogFileMessageList)
                for x in range(size):
                    log = self.m_LogFileMessageList[x]
                    if(log.m_ID == message.m_ID and len(log.m_Reason) == 0):
                        self.occurenceInspektionMessage = True
                        result = True
                        inspektionMessageID = log.m_ID
                        log.m_Level = 2
                        break
                break
        return result

    def parseFiles(self):
        'Konfigurationsdatei parsen'
        try:
            f = open(KonfigFileName, "r")
            f.close()
            self.dmgXMLPasre.setFileName(KonfigFileName)
            self.dmgXMLPasre.parseFileName()
        except:
            f = open(KonfigFileName, "w")
            f.close()
            self.dmgXMLPasre.createElementNS(machineCheckConfig, KonfigFileName)
            self.dmgXMLPasre.addTag(machineCheckConfig, IKEYS)
            self.dmgXMLPasre.addTag(machineCheckConfig, lastTotalUpTime, str(0))
            self.dmgXMLPasre.addTag(machineCheckConfig, lastTotalProgramTime, str(0))
            self.dmgXMLPasre.parseFileName()

        'Protokolldatei parsen'
        try:
            f = open(LogFileName, "r")
            self.dmgXMLLogFile.setFileName(LogFileName)
            self.dmgXMLLogFile.parseFileName()
            self.readLogFile()
            f.close
        except:

            f = open(LogFileName, "w")
            self.dmgXMLLogFile.createElementNS(machineCheckLog, LogFileName)
            'Ist ResetCounter aktive, dann erstelle die Protokoll-Datei neu'
            if(self.resetCounterActive):
                sizeMessageData = len(self.m_DefinitionFileMessageList)
                for i in range(sizeMessageData):
                    message = self.m_DefinitionFileMessageList[i]
                    if(message.m_Level == MAINTENANCE or message.m_Level == INSPECTION):
                        listAttr = []
                        dictAttr = {}
                        dictAttr['Name'] = ID
                        dictAttr['Value'] = message.m_ID
                        listAttr.append(dictAttr)
                        attrList = self.createNewAttrListForAppearanceMessage(message.m_ID)
                        node = self.dmgXMLLogFile.getNode(machineCheckLog)
                        if(node != None):
                            self.dmgXMLLogFile.addAttribut(node, ALARM, listAttr)

                        node = self.dmgXMLLogFile.getNode(ALARM, message.m_ID)
                        if(node != None):
                            self.dmgXMLLogFile.addAttribut(node, OCCURRENCE, attrList)

                        node = self.dmgXMLLogFile.getNode(ALARM, message.m_ID)
                        if(node != None):
                            self.dmgXMLLogFile.addAttribut(node, ACKNOWLEDGEMENT, attrList)

                        lastNode, nextNode = self.dmgXMLLogFile.getLastAndNextNode(ALARM, ACKNOWLEDGEMENT, message.m_ID)
                        if(lastNode != None):
                            self.dmgXMLLogFile.appendNewTag(nextNode,USER, self.smartKeyID)
                            lastNode, acknowledgNode = self.dmgXMLLogFile.getLastAndNextNode(ALARM, ACKNOWLEDGEMENT, message.m_ID)
                            if(acknowledgNode != None):
                                self.dmgXMLLogFile.appendNewTag(acknowledgNode,REASON, RESET_COUNTER)
            self.readLogFile()
            f.close

    def reset(self, resetUpTime=None, resetPgmTime=None):
        xVal = int(float(resetPgmTime))
        if( xVal == 0):
            xVal = 1
        yVal = int(float(resetUpTime))
        if(yVal == 0):
            yVal = 1

        self.occurenceInspektionMessage = False
        self.resetCounterActive = True
        'Stop Timer'
        if(self.TimerID != 0):
            gobject.source_remove(self.TimerID)
            del self.TimerID
        'Liste löschen'
        size = len(self.m_LogFileMessageList)
        for x in range(size):
            self.m_LogFileMessageList.remove(self.m_LogFileMessageList[0])

        size = len(self.m_SmartKeyList)
        for x in range(size):
            self.m_SmartKeyList.remove(self.m_SmartKeyList[0])

        'Logdatei löschen'
        os.remove(LogFileName)
        'Parse File löschen'
        del self.dmgXMLLogFile

        'Konfigurationsdatei löschen'
        os.remove(KonfigFileName)
        del self.dmgXMLPasre
        self.totalProgramTimeFromPLC = xVal
        if(Simulate == 0):
            com.write(PLCAddress + Set_Auto_Betrieb_run, xVal)
            com.write(PLCAddress + Set_Maschine_EIN, yVal)
        else:
            self.totalProgramTimeFromPLC = float(resetPgmTime)


        self.dmgXMLPasre   = DMG_XMLParser.DMGXMLParser()
        self.dmgXMLLogFile = DMG_XMLParser.DMGXMLParser()
        self.m_MessageID = -1
        self.parseFiles()
        self.startTimer()


    def __init__(self, machineCheckView=None):

        self.dmgXMLPasre                            = DMG_XMLParser.DMGXMLParser()
        self.dmgXMLLogFile                          = DMG_XMLParser.DMGXMLParser()
        self.dmgXMLDefnitionFile                    = DMG_XMLParser.DMGXMLParser()
        self.dmgXMLBaseTechnologieFile              = DMG_XMLParser.DMGXMLParser()
        self.m_MachineCheckView                     = machineCheckView
        self.InspektionReminder                     = 4 * 60 * 60
        self.WartungReminder                        = 8 * 60 * 60
        self.ReminderInspektionCounter              = 0
        self.ReminderMaintenanceCounter             = 0
        self.m_MessageID                            = 0
        self.PicturCodeMaintenance                  = False
        self.PicturCodeInspektionOrangeStatic       = False
        self.PicturCodeInspektionRedStatic          = False
        self.m_MessageID                            = None
        self.m_Head                                 = None
        self.m_Body                                 = None
        self.m_PicturCode                           = None
        self.m_Level                                = None
        self.m_Page                                 = 0
        self.smartKeyID                             = 0
        self.m_SmartKeyActive                       = False
        self.totalProgramTimeFromPLC                = 0
        self.totalTimeFromPLC                       = 0
        self.counter                                = 0
        self.m_PgmHour                              = 0
        self.m_AppearenceTime                       = None
        self.m_AppearencePgm                        = None
        self.m_Comment                              = None
        self.m_SmartKeyList                         = []
        self.m_LngTextList                          = []
        self.m_lstBaseTechnologie                   = []
        self.m_showReminder                         = False
        self.PGMTIMETEXT                            = ""
        self.MaintenanceText                        = ""
        self.m_NextMaintenance                      = 0
        self.afterTimeMessageID                     = 0
        self.occurenceInspektionMessage             = False
        self.Minute                                 = 0
        self.resetCounterActive                     = False
        self.SAAvailable                            = False
        self.dumyMsgId                              = 0
        self.m_MTypNummer                           = None
        self.m_BTIndex                              = 0
        self.m_iKeyPw                               = None

        'Version eintragen'
        version = DMG_Version.DMG_Version("dmgversion.txt")
        version.setVersion(MACHINECHECK, VERSION)

        'SmartKeyID  abfragen'
        if(Simulate == 0):
            com.runReadHotlink(PLCAddress + DG_PIT_Unicat_Nummer, self.CallBackSmartKeyID)
            com.runReadHotlink(PLCAddress + "BG_AKTIVE_BA", self.CallBackKeySwitchID)

        self.parseFiles()

        'BaseTechnologie File parsen'
        try:
            f = open(BaseTechnologieFileName, "r")
            self.dmgXMLBaseTechnologieFile.setFileName(BaseTechnologieFileName)
            self.dmgXMLBaseTechnologieFile.parseFileName()
            self.readBaseTechnologieFile()
        except:
            print "cannot open BastechnologieFile"

        'get MaschineNummer Type'
        txt = com.read("\\TABLE\\'" + PathTableMTYP + "'\\NR\\" + "1" + "\\*")
        if (txt != None):
            self.m_MTypNummer = txt['VALUE']
            strMTyp = ""
            for iLen in range(4):
                strMTyp+=self.m_MTypNummer[iLen]
            self.m_MTypNummer = strMTyp

        'find BT Index from BaseXMLFile'
        sizeBaseFile = len(self.m_lstBaseTechnologie)
        for x in range (sizeBaseFile):
            myBasisTechnologie = self.m_lstBaseTechnologie[x]
            if( int(myBasisTechnologie.m_MTYP) == int(self.m_MTypNummer)):
                self.m_BTIndex = int(myBasisTechnologie.m_BT)
                break;
        '''
        self.smartKeyID = 10000000
        self.calculateiKey()
        '''
        self.readTotalAndProgramTimeFromPLC()
        if(Simulate == 1):
            TotalProgrammTime   = self.dmgXMLPasre.getXMLTagValue(lastTotalProgramTime)
            self.totalProgramTimeFromPLC = TotalProgrammTime
            self.smartKeyID = 130000161

        self.readSmartKeyConfig()

        'Sprache ermitteln'
        languageID = self.readLanguage()

        'allgemeine Texte aus der Sprechdatei holen'
        FileLng = None
        strlngFileName = LanguageFileName%(languageID)
        try:
            FileLng = open(strlngFileName, "r")
        except:
            strlngFileName = LanguageFileName%("eng")
            FileLng = open(strlngFileName, "r")

        if(FileLng != None):
            line = FileLng.readline()
            while line:
                length = len(line)
                dictAttr = {}
                findValueText = False
                strKey = ""
                strValue = ""
                result = False
                for i in range(length):
                    if (line.find(';') == -1 ):
                        if(line[i] != " " and not findValueText and line[i] != '"'):
                            strKey+= line[i]
                            dictAttr['Key']= strKey

                        if(line[i] == '"' ):
                            findValueText = True
                            i+=1
                            while(1):
                                if(line[i] == '"'):
                                    self.m_LngTextList.append(dictAttr)
                                    break
                                strValue+= line[i]
                                dictAttr['Value']= strValue
                                i+=1
                        if(line[i] != "\\" and findValueText):
                            break

                line = FileLng.readline()

        self.PGMTIMETEXT        = self.getText(PROGRAM_RUNTIME)
        self.MaintenanceText    = self.getText(NEXT_MAINTENANCE_AFTER)
        self.InspektionText    = self.getText(NEXT_INSPECTION_AFTER)

        self.m_Level = 0
        self.m_MessageID = 0

        definitionFileName = DefinitionFile %(languageID)
        'Defintionsdatei parsen'
        findDefinitionFile = False
        File = None
        try:
            File = open(definitionFileName, "rb")
            findDefinitionFile = True
        except:
            try:
                definitionFileName = DefinitionFile %("eng")
                File = open(definitionFileName, "rb")
                findDefinitionFile = True
            except:
                findDefinitionFile = False
                txt = self.getText(MachineCheckInvalid)
                self.m_MachineCheckView.showMessage(None, txt, None, None, BLUE_STATIC)
                'Timer wird nicht mehr gestartet. Restart der Anwendung ist notwendig'
                return

        if(findDefinitionFile):
            xmlData = self.getXMLDataFromDefinitionFile(File)
            self.readDataFromDefinitionFile(xmlData)
            File.close()

            'sichernstellen, ob SA vorhanden ist'
            result = False
            sizeLogDatei = len(self.m_LogFileMessageList)
            if(not self.isServiceAgentConnected()):
                self.hideAllUnQuitMaintenaceMessages()
                self.writeTotalAndProgramTimeToConfigFile()
                x = 0
                for i in range(sizeLogDatei):
                    if(self.occurenceInspektionMessage):
                        x = sizeLogDatei - x -1
                    else:
                        x = i
                    message = self.m_LogFileMessageList[x]
                    'Hier unbehandelte Meldungen anzeigen.'
                    if(int (message.m_ID) > 0 and message.m_ShowMessage):
                        self.m_MessageID = int (message.m_ID)
                        result = True
                        break
                message = self.m_LogFileMessageList[2]
                if(not result):
                    message.m_ShowMessage = True
                else:
                     message.m_ShowMessage = False
                self.m_LogFileMessageList[2] = message

                self.Minute = 0
                self.onTimerEvent()
                if(Simulate == 0 and SUMULATE_ITNC == 0):
                    self.Minute = 60

                self.m_Head, self.m_Body, self.m_Page = self.getMessageDiscription(self.m_MessageID)
                self.getMessageLevel()
                self.m_MachineCheckView.showMessage(self.m_Head, self.m_Body, self.m_AppearenceTime, self.m_AppearencePgm, self.m_PicturCode, self.m_Level)

                'Timer starten'
                self.TimerID = gobject.timeout_add(1000, self.onTimerEvent)

            else:
                self.dumyMsgId = self.m_MessageID
                self.hideAllMessages()
                txt = self.getText(SERVICE_AGENT_INSTALLED)
                'SA Meldung im Fenster anzeigen'
                self.m_MachineCheckView.showMessage(None, txt, None, None, BLUE_STATIC, 0)

        self.readTotalAndProgramTimeFromPLC()

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse "MachineCheckView" zeigt die Meldungen an.
                                 zeigt ein Regstrierfenster.
                                 verwaltet die Softkey-Anzeige bzw. die Softkeydrücke
Autor: Waddah Ostah28
Datum: 1.12.2010
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
class MachineCheckView(Fixed):

    def initialImags(self, image, imageName):
        image.set_from_file(ICNON_SYNTAX + imageName)
        self.put(image, 0,0)
        image.hide()

    def onTimerEvent(self):

        self.AppearanceTimeLabel.set_text("")
        self.PgmLabel.set_text("")
        gobject.source_remove(self.TimerID)
        self.IgnorImage.show()
        self.OKImage.show()
        self.Nextimage.show()

        self.IgnorButton.set_sensitive(True)
        self.OKButton.set_sensitive(True)
        self.NextButton.set_sensitive(True)

        if(self.IgnorButton.get_active()):
            self.IgnorButton.set_active(False)
            if(self.machineCheckData != None):
                self.machineCheckData.showNextMessage()
                self.machineCheckData.startTimer()
        if(self.OKButton.get_active()):
            self.OKButton.set_active(False)
            if(self.machineCheckData != None):
                self.machineCheckData.showNextMessage()
                self.machineCheckData.startTimer()

    def showNextTimeMaintenanceAfter(self, value):
        self.nextTimeMaintenanceLabel.set_text(value)

    def showNextTimeInspektionAfter(self, value):
        self.nextTimeInspektionLabel.set_text(value)

    def showResetCodeText(self):
        self.showPWText = True
        self.EntrySmartPW.set_sensitive(True)
        self.EntrySmartPW.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse('#008000'))
        txt = self.machineCheckData.getText(PLEASE_ENTER_RESET_CODE)
        self.PWBuffer.set_text(txt)

        self.smartIcon2Image.hide()
        self.areaIDEntry.set_size_request(0, 0)
        self.EntrySmartID.hide()

        self.SmartKeyText.hide()

        self.UpTimeImage.show()
        txtResetUpTime  = self.ResetUpTimeBuffer.get_text(self.ResetUpTimeBuffer.get_start_iter(), self.ResetUpTimeBuffer.get_end_iter())
        txtResetPgmTime = self.ResetPgmTimeBuffer.get_text(self.ResetPgmTimeBuffer.get_start_iter(), self.ResetPgmTimeBuffer.get_end_iter())

        self.ResetUpTimeBuffer.set_text(str(float(self.machineCheckData.totalTimeFromPLC/3600)))

        self.ResetUpTimeTextView.show()
        self.areaPWEntry.set_size_request(0, 0)

        self.ResetPgmTimeBuffer.set_text(str(float(self.machineCheckData.totalProgramTimeFromPLC/3600)))

        self.ProgrammRunTimeImage.show()
        self.ResetPgmTextView.show()


    def resetCounter(self, resetUpTime=None, resetPgmTime=None):
        self.EntrySmartPW.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse('#008000'))
        x = float(resetUpTime) * 3600
        y = float(resetPgmTime) * 3600
        self.machineCheckData.reset(x, y)
        #self.IgnorButton.set_active(False)

    def onButtonClicked(self, button):
        if(Simulate == 0):
            self.WindowParent = MyGlobal.UPPERSCREEN_WINDOW
            self.m_UpperScreenWin = MyGlobal.UPPERSCREEN_MODUL
            self.WindowParent.Focus(jh.focus.LEAVE)
        if(button == self.NextButton and self.machineCheckData != None):
            self.machineCheckData.showNextMessage()
        elif((button == self.IgnorButton) and self.IgnorButton.get_active() and self.m_Level < 0):
            self.showResetCodeText()
        elif((button == self.IgnorButton) and not self.IgnorButton.get_active() and self.m_Level < 0):
            self.PWBuffer.set_text("")
            self.smartIcon2Image.show()
            self.SmartKeyText.show()
            self.EntrySmartID.show()
            self.UpTimeImage.hide()
            self.ResetUpTimeTextView.hide()
            self.ProgrammRunTimeImage.hide()
            self.ResetPgmTextView.hide()
            self.showIDAndPW()
        elif(button == self.IgnorButton and self.IgnorButton.get_active() or button == self.OKButton and self.OKButton.get_active()):
            messageInspektion = False
            colorHead = None
            if(button == self.IgnorButton and self.machineCheckData != None):
                colorHead = self.HeadLabel.get_colormap().alloc_color(self.headColorsRED)
                self.machineCheckData.ignorMessage()
            elif(self.machineCheckData != None):
                colorHead = self.HeadLabel.get_colormap().alloc_color(self.GreenColor)
                self.machineCheckData.ignorMessage(True)
            self.IgnorButton.set_sensitive(False)
            self.IgnorImageGrayButton.show()
            self.OKButton.set_sensitive(False)
            self.OKGrayImage.show()
            self.NextButton.set_sensitive(False)
            self.NextGrayimage.show()

            self.HeadLabel.modify_fg(gtk.STATE_NORMAL, colorHead)
            self.TimerID = gobject.timeout_add(5000, self.onTimerEvent)
        else:
            a = 0

    def updateStateOkButton(self):
        result = None
        pw = None
        self.OKImage.hide()
        self.OKGrayImage.hide()
        self.OKButton.set_sensitive(False)
        self.IgnorButton.set_sensitive(False)
        self.IgnorButton.set_active(False)

        self.IgnorImage.hide()
        self.IgnorImageGrayButton.hide()
        self.Resetimage.hide()

        if(self.machineCheckData != None):
            result, pw = self.machineCheckData.isInspektionKeyValid()
            smartID, pw = self.machineCheckData.getIDAndPW()
        if(result and pw!= None and self.m_Level > 1):
            self.IgnorImage.show()
            self.IgnorButton.set_sensitive(True)
            self.OKImage.show()
            self.OKButton.set_sensitive(True)

        elif(self.m_Level == -1):
            self.showIDAndPW()
        elif(self.m_Level == 1):

            self.IgnorImageGrayButton.hide()
            self.IgnorImage.show()
            self.OKGrayImage.hide()
            self.OKImage.show()

            self.OKButton.set_sensitive(True)
            self.IgnorButton.set_sensitive(True)
            self.showIDAndPW()

        elif(self.m_Level > 1):
            self.IgnorImageGrayButton.show()
            self.OKGrayImage.show()

    def showKeyTextTitle(self, servicekeyAvailable=None):
        if(MyGlobal.UPPERSCREEN_WINDOW != None ):
            self.WindowParent = MyGlobal.UPPERSCREEN_WINDOW
            self.m_UpperScreenWin = MyGlobal.UPPERSCREEN_MODUL
            ret, windownumber, size, winMode = self.isWindowselectet()
            if(winMode == 1 and ret):
                if(not servicekeyAvailable):
                    self.m_UpperScreenWin.caption1.SetText(MACHINECHECK, windownumber, size)
                else:
                    self.m_UpperScreenWin.caption1.SetText(MACHINECHECK_IKEY_TEXT, windownumber , size)
            elif(winMode == 2 and ret):
                if(not servicekeyAvailable):
                    self.m_UpperScreenWin.caption2.SetText(MACHINECHECK, windownumber, size)
                else:
                    self.m_UpperScreenWin.caption2.SetText(MACHINECHECK_IKEY_TEXT, windownumber , size)


    def showIDAndPW(self):
        self.EntrySmartPW.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse('#008000'))
        'Wenn kein Servicekey vorhanden ist, dann image und der Text in Eingabefeld ausblenden'
        self.Resetimage.hide()
        self.PWBuffer.set_text("")
        self.isIgnorButtonActive = False
        if(self.machineCheckData != None):
            self.showKeyTextTitle(False)
            smartID, smartPW = self.machineCheckData.getIDAndPW()
            self.EntrySmartID.set_sensitive(True)
            self.EntrySmartPW.set_sensitive(True)
            'if Basis index not found, them disabled SmartID and PW Edit an show messages for user'
            if(self.machineCheckData.m_BTIndex == 0):
                self.showPWText = True
                self.EntrySmartID.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.bodyColorsBLUE))
                self.IDBuffer.set_text(self.machineCheckData.getText("NO_IKEYS_REGISTRABLE"))
                self.EntrySmartID.set_sensitive(False)
                self.EntrySmartPW.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.bodyColorsBLUE))
                self.PWBuffer.set_text(self.machineCheckData.getText("CHECK_CONFIGURATIONFILE"))
                self.EntrySmartPW.set_sensitive(False)
            elif(smartID != None):
                if(not self.machineCheckData.m_SmartKeyActive):
                    self.IDBuffer.set_text("")
                else:
                    self.IDBuffer.set_text(str(smartID))
            else:
                self.IDBuffer.set_text("")

            if(smartPW != None and smartPW == 13 and self.m_Level == -1):
                self.showKeyTextTitle(True)
                self.Resetimage.show()
                self.IgnorButton.set_sensitive(True)
                self.isIgnorButtonActive = True
            elif(smartPW != None and smartPW != 13 and self.m_Level == -1):
                self.showKeyTextTitle(True)
                self.IgnorButton.set_sensitive(False)
                self.PWBuffer.set_text(str(smartPW))
            elif(self.m_Level == -1):
                self.IgnorButton.set_sensitive(False)
                if(self.machineCheckData.m_BTIndex > 0):
                    self.EntrySmartPW.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.headColorsRED))
                    self.PWBuffer.set_text("")

    def showSoftkeyImages(self):
        self.Resetimage.hide()
        self.NextGrayimage.hide()
        self.IgnorImageGrayButton.hide()
        self.OKGrayImage.hide()
        self.isIgnorButtonActive = False
        self.IgnorButton.set_active(False)

        if(self.m_Level == 0 or self.m_Level < 0):
            self.Nextimage.show()
            self.IgnorImage.hide()
            self.IgnorButton.set_sensitive(False)
            self.OKButton.set_sensitive(False)
            self.OKImage.hide()
            'RegstrierFenster ist angezeigt'
            if(self.m_Level < 0 and self.machineCheckData != None):
                self.showIDAndPW()
        if(self.m_Level == 1):
            self.showKeyTextTitle(False)
            self.IgnorButton.set_sensitive(True)
            self.OKButton.set_sensitive(True)
            self.IgnorImage.show()
            self.OKImage.show()

        if(self.m_Level == 2):
            self.updateStateOkButton()

    def showSmartKeyWindow(self, keyID=None, keyPW=None, level=None):
        self.MaintenanceImageBlink.hide()
        self.MaintenanceImageStatic.hide()
        self.InspektionImageBlink.hide()
        self.InspektionImageStatic.hide()
        self.InspektionRedBlink.hide()
        self.InspektionRedStatic.hide()
        self.HeadLabel.set_text("")
        self.BodyLabel.set_text("")
        self.AppearanceTimeLabel.set_text("")
        self.PgmLabel.set_text("")
        self.smartKeyImage.show()
        self.smartIcon1Image.show()
        self.smartIcon2Image.show()
        self.SmartKeyText.show()
        self.EntrySmartID.show()
        self.EntrySmartPW.show()
        self.nextTimeMaintenanceLabel.show()
        self.nextTimeInspektionLabel.show()

        self.m_Level = level
        'Hier muss zwei Eingabefelder vorhanden und die zugehörige Werten angezeigt werden'
        txt = self.machineCheckData.getText(ENTER_ID_AND_PASSWORD)
        self.SmartKeyText.set_text(txt)

        self.showSoftkeyImages()
        smartID, smartPW = self.machineCheckData.getIDAndPW()

        if(MyGlobal.UPPERSCREEN_WINDOW != None and smartPW != None):
            self.showKeyTextTitle(True)

    def isWindowselectet(self):
          ret = False
          windownumber  = 0
          winMode = 0
          size = 0
          if(MyGlobal.UPPERSCREEN_WINDOW != None):
             self.WindowParent = MyGlobal.UPPERSCREEN_WINDOW
             self.m_UpperScreenWin = MyGlobal.UPPERSCREEN_MODUL
             size = len(self.m_UpperScreenWin.WinList1)
             for i in range(size):
                myobjectref =self.m_UpperScreenWin.WinList1[i]
                if(myobjectref == self and self.m_UpperScreenWin.WindowNumber1 == i):
                    if((i +1) < size):
                        windownumber = i + 1
                    else:
                        windownumber = size
                    winMode = 1
                    ret = True
                    break

             if(not ret):
                 size = len(self.m_UpperScreenWin.WinList2) -1 + self.m_UpperScreenWin.OM_X_active
                 for i in range(size):
                    myobjectref =self.m_UpperScreenWin.WinList2[i]
                    if(myobjectref == self and self.m_UpperScreenWin.WindowNumber2 == i):
                        if((i +1) < size):
                            windownumber = i + 1
                        else:
                            windownumber = size
                        winMode = 2
                        ret = True

                        break

          return (ret, windownumber, size, winMode)

    def showPopUpWIndow(self):
        if(MyGlobal.UPPERSCREEN_WINDOW != None):
            self.WindowParent = MyGlobal.UPPERSCREEN_WINDOW
            self.m_UpperScreenWin = MyGlobal.UPPERSCREEN_MODUL
            ret = False
            size = len(self.m_UpperScreenWin.WinList1)
            for i in range(size):
                myobjectref =self.m_UpperScreenWin.WinList1[i]
                if(myobjectref == self):
                    ret = True
                    size_ = len(self.m_UpperScreenWin.WinList1)
                    for x in range(size_):
                        myobjectref1 = self.m_UpperScreenWin.WinList1[x]
                        if(myobjectref1 != self):
                            myobjectref1.hide()

                    self.m_UpperScreenWin.WindowNumber1 = i
                    myobjectref.show()
                    self.showKeyTextTitle(False)
                    break
            if(not ret):
                size = len(self.m_UpperScreenWin.WinList2)
                for i in range(size):
                    myobjectref =self.m_UpperScreenWin.WinList2[i]
                    if(myobjectref == self):
                        self.m_UpperScreenWin.WindowNumber2 = i
                        ret = True
                        size_ = len(self.m_UpperScreenWin.WinList2)
                        for x in range(size_):
                            myobjectref1 = self.m_UpperScreenWin.WinList2[x]
                            if(myobjectref1 != self):
                                myobjectref1.hide()

                        myobjectref.show()
                        self.showKeyTextTitle(False)
                        break

    def showMessage(self, head=None, body=None, appearanceTime=None, PgmTime=None, picturCode=None, level=None):
        colorHead = None
        colorBody = None
        self.HeadLabel.set_text("")
        self.BodyLabel.set_text("")
        self.AppearanceTimeLabel.set_text("")
        self.smartKeyImage.hide()
        self.smartIcon2Image.hide()
        self.smartIcon1Image.hide()

        self.UpTimeImage.hide()
        self.ResetUpTimeTextView.hide()
        self.ProgrammRunTimeImage.hide()
        self.ResetPgmTextView.hide()

        self.SmartKeyText.hide()
        self.EntrySmartID.hide()
        self.EntrySmartPW.hide()
        self.InspektionImageStatic.hide()
        self.InspektionImageBlink.hide()
        self.InspektionRedStatic.hide()
        self.InspektionRedBlink.hide()
        self.MaintenanceImageBlink.hide()
        self.MaintenanceImageStatic.hide()
        self.nextTimeMaintenanceLabel.hide()
        self.nextTimeInspektionLabel.hide()

        self.areaIDEntry.set_size_request(0, 0)
        self.areaPWEntry.set_size_request(0, 0)

        if(level != None):
            self.m_Level = level

        colorHead = self.HeadLabel.get_colormap().alloc_color(self.headColorsBLUE)
        colorBody = self.HeadLabel.get_colormap().alloc_color(self.bodyColorsBLUE)
        color = self.HeadLabel.get_colormap().alloc_color(self.headColorsBLUE)
        self.standardImage.show()

        if(picturCode != None and picturCode == YELLOW_STATIC or picturCode != None and picturCode == YELLOW_BLINK):
            colorHead = self.HeadLabel.get_colormap().alloc_color(self.headColorsYELLOW)
            colorBody = self.HeadLabel.get_colormap().alloc_color(self.bodyColorsYELLOW)
            if(picturCode != None and picturCode == YELLOW_BLINK):
                self.MaintenanceImageBlink.show()
            elif(picturCode != None and picturCode == YELLOW_STATIC):
                self.MaintenanceImageStatic.show()

        elif(picturCode != None and picturCode == ORANGE_STATIC or picturCode != None and picturCode == ORANGE_BLINK):
            colorHead = self.HeadLabel.get_colormap().alloc_color(self.headColorsORANGE)
            colorBody = self.HeadLabel.get_colormap().alloc_color(self.bodyColorsORANGE)
            if(picturCode != None and picturCode == ORANGE_BLINK):
                self.InspektionImageBlink.show()
            elif(picturCode != None and picturCode == ORANGE_STATIC):
                self.InspektionImageStatic.show()

        elif(picturCode != None and picturCode == RED_STATIC or picturCode != None and picturCode == RED_BLINK):
            colorHead = self.HeadLabel.get_colormap().alloc_color(self.headColorsRED)
            colorBody = self.HeadLabel.get_colormap().alloc_color(self.bodyColorsRED)
            if(picturCode != None and picturCode == RED_BLINK):
                self.InspektionRedBlink.show()
            elif(picturCode != None and picturCode == RED_STATIC):
                self.InspektionRedStatic.show()

        if(head != None):
            self.HeadLabel.modify_fg(gtk.STATE_NORMAL, colorHead)
            self.HeadLabel.set_text(head)
        if(body != None):
            self.BodyLabel.modify_fg(gtk.STATE_NORMAL, colorBody)
            self.BodyLabel.set_text(body)
        if(appearanceTime != None):
            self.AppearanceTimeLabel.modify_fg(gtk.STATE_NORMAL, color)
            self.AppearanceTimeLabel.set_text(appearanceTime)
        if(PgmTime != None):
            self.PgmLabel.modify_fg(gtk.STATE_NORMAL, color)
            self.PgmLabel.set_text(PgmTime)

        if(self.m_Level > 0):
            self.showPopUpWIndow()
        else:
            if(MyGlobal.UPPERSCREEN_WINDOW != None):
                self.WindowParent = MyGlobal.UPPERSCREEN_WINDOW
                self.m_UpperScreenWin = MyGlobal.UPPERSCREEN_MODUL
                self.showKeyTextTitle(False)

        self.showSoftkeyImages()

    def setCommentLabelText(self, txt):
        self.CommentLabel.set_markup(txt)

    def onFocus(self, widget, event):
        if(Simulate == 0):
            self.WindowParent = MyGlobal.UPPERSCREEN_WINDOW
            self.m_UpperScreenWin = MyGlobal.UPPERSCREEN_MODUL
            self.WindowParent.Focus(jh.focus.GET)
        color = widget.get_colormap().alloc_color("#FFD791")
        widget.modify_base(gtk.STATE_NORMAL, color)
        widget.set_cursor_visible(True)
        self.showPWText = False
        if(widget == self.EntrySmartID):
            self.areaIDEntry.set_size_request(self.widthArea, self.heightArea)
            self.IDBuffer.set_text("")
        elif(widget == self.EntrySmartPW):
            self.areaPWEntry.set_size_request(self.widthArea, self.heightArea)
            self.PWBuffer.set_text("")
            self.EntrySmartPW.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.headColorsRED))
        elif(widget == self.ResetUpTimeTextView):
            self.PointAvailable = False
            self.eb.set_size_request(100,28)
            self.ResetUpTimeBuffer.set_text("")

        elif(widget == self.ResetPgmTextView):
            self.PointAvailable = False
            self.ebPgm.set_size_request(100,28)
            self.ResetPgmTimeBuffer.set_text("")

    def onUpdateResetCodeText(self):
        self.showResetCodeText()


        return False
    def onKeyPressed(self, widget, event):
        strSoftkey = gtk.gdk.keyval_name(event.keyval)
        startIterID = self.IDBuffer.get_start_iter()
        EndIterID = self.IDBuffer.get_end_iter()
        startIterPW = self.PWBuffer.get_start_iter()
        EndIterPW = self.PWBuffer.get_end_iter()
        txtID = self.IDBuffer.get_text(startIterID, EndIterID)
        txtPW = self.PWBuffer.get_text(startIterPW, EndIterPW)
        txtResetUpTime  = self.ResetUpTimeBuffer.get_text(self.ResetUpTimeBuffer.get_start_iter(), self.ResetUpTimeBuffer.get_end_iter())
        txtResetPgmTime = self.ResetPgmTimeBuffer.get_text(self.ResetPgmTimeBuffer.get_start_iter(), self.ResetPgmTimeBuffer.get_end_iter())
        if(string.upper(strSoftkey) == "KP_ENTER" or string.upper(strSoftkey) == "RETURN"):
            if(self.WindowParent != None):
                self.WindowParent.Focus(jh.focus.LEAVE)
                self.WindowParent.set_focus(None)
            if(widget == self.EntrySmartPW and self.isIgnorButtonActive and len(txtPW) == 0):
                gobject.timeout_add(30, self.onUpdateResetCodeText)
            elif(widget == self.EntrySmartPW and self.IgnorButton.get_active() and len(txtPW) > 0  and (int(txtPW) == RESET_CODE) and len(txtResetUpTime) > 0 and len(txtResetUpTime) > 0):
                self.resetCounter(txtResetUpTime, txtResetPgmTime)

            elif(widget == self.EntrySmartPW):
                if(len(txtPW) > 0 and self.machineCheckData != None and len(txtID) > 0):
                    result = self.machineCheckData.setInspektionKey(txtID, txtPW)
                    if(result):
                        self.EntrySmartPW.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse('#008000'))
                        if(MyGlobal.UPPERSCREEN_WINDOW != None):
                            self.showKeyTextTitle(False)

    def showErrorBaseTIndexText(self):
        self.PWBuffer.set_text("BT invalid !")


    def onKillFocus(self,widget, event):
        self.showPWText     = False
        self.areaIDEntry.set_size_request(0, 0)
        self.areaPWEntry.set_size_request(0, 0)
        self.eb.set_size_request(0,0)
        self.ebPgm.set_size_request(0,0)
        color = widget.get_colormap().alloc_color("white")
        widget.modify_base(gtk.STATE_NORMAL, color)
        if(Simulate == 0):
            self.WindowParent.Focus(jh.focus.LEAVE)

    def on_expose(self, da, event, *args):
        self.gdkwin = None
        self.gdkwinID = self.areaIDEntry.window
        self.gdkwinPW = self.areaPWEntry.window

        if(self.EntrySmartID.is_focus()):
            self.gdkwin = self.gdkwinID
        else:
            self.gdkwin = self.gdkwinPW

        gc = self.gdkwin.new_gc()
        gc.foreground = self.gdkwin.get_colormap().alloc_color("#FF9A00")
        self.gdkwin.draw_rectangle(gc, True, 0, 0, self.widthArea, self.heightArea)

    def onInsertText(self, textbuffer, iter, text, length):

        if(not self.showPWText):
            length  = textbuffer.get_char_count()
            if(length > 0 and len(text) > 0 and  text == "." and not self.PointAvailable):
                self.PointAvailable = True
                return
            elif(not text.isdigit() or int(length) > 14):
                textbuffer.stop_emission('insert-text')
            elif(text.isdigit() and int (text) >= 0 and int (text) <= 14):
                return

    def onHideAllImages(self):
        self.smartKeyImage.hide()
        self.smartIcon2Image.hide()
        self.smartIcon1Image.hide()
        self.UpTimeImage.hide()
        self.ResetUpTimeTextView.hide()
        self.ProgrammRunTimeImage.hide()
        self.ResetPgmTextView.hide()
        self.SmartKeyText.hide()
        self.EntrySmartID.hide()
        self.EntrySmartPW.hide()
        self.MaintenanceImageStatic.hide()
        self.MaintenanceImageBlink.hide()
        self.InspektionImageStatic.hide()
        self.InspektionImageBlink.hide()
        self.InspektionRedStatic.hide()
        self.InspektionRedBlink.hide()
        self.standardImage.hide()
        self.machineCheckData = DMGMachineCheck(self)
        self.showSoftkeyImages()
        return False

    def __init__( self, parent=None, UpperScreenWindow=None):

        self.headColorsBLUE      = "#0A2080"
        self.headColorsYELLOW    = "#D0A000"
        self.headColorsORANGE    = "#E07010"
        self.headColorsRED       = "#C00000"
        self.bodyColorsBLUE      = "#0A2080"
        self.bodyColorsYELLOW    = "#807000"
        self.bodyColorsORANGE    = "#804000"
        self.bodyColorsRED       = "#A00000"
        self.GreenColor          = "#008000"

        self.WIDTH          = 1146/ 2
        self.ParentWidh     = 472
        self.HEIGHT         = 230
        leftHeadLabel       = 140
        topHeadLabel        = 10

        width               = 210
        self.heightHeadLabel     = 30
        heightBodyLabel     = 170
        topBodyLabel        = 40

        heightCommentLabel  = 20
        leftCommentLabel    = 10
        topCommentLabel     = 191
        topAppearanceLabel  = topCommentLabel + 16

        widthButton         = 100
        heightVutton        = 76
        leftButton          = 472
        topNextButton       = 2
        self.m_Level        = 0
        self.smartKeyID     = 0
        widthSmartKeyImage  = 470
        heightSmartKeyImage = 200

        KeyPWImage          =  50
        leftKeyPWImage      =  60
        topKeyPWImage       =  110
        topSmartKeyText     = 50
        self.widthArea      = 295
        self.heightArea     = 30
        self.machineCheckData = None
        self.showPWText     = False
        self.isIgnorButtonActive = False
        self.PointAvailable = False
        Fixed.__init__( self )

        self.WindowParent     = MyGlobal.UPPERSCREEN_WINDOW
        self.m_UpperScreenWin = MyGlobal.UPPERSCREEN_MODUL
        self.set_size_request(self.WIDTH,  self.HEIGHT)

        'Standard Image Blau-statisch initialisieren'
        self.standardImage = Image()
        self.initialImags(self.standardImage, "level00.png")

        'Wartung Imgae statisch initialisieren'
        self.MaintenanceImageStatic = Image()
        self.initialImags(self.MaintenanceImageStatic, "level20.png")

        'Wartung Imgae Blink initialisieren'
        self.MaintenanceImageBlink = Image()
        self.initialImags(self.MaintenanceImageBlink, "level21.png")

        'Inspektion Imgae statisch initialisieren'
        self.InspektionImageStatic = Image()
        self.initialImags(self.InspektionImageStatic, "level30.png")

        'Inspektion Imgae Blink initialisieren'
        self.InspektionImageBlink = Image()
        self.initialImags(self.InspektionImageBlink, "level31.png")

        'Inspektion Imgae rot-Static initialisieren'
        self.InspektionRedStatic = Image()
        self.initialImags(self.InspektionRedStatic, "level40.png")

        'Inspektion Imgae rot-Static initialisieren'
        self.InspektionRedBlink = Image()
        self.initialImags(self.InspektionRedBlink, "level41.png")

        'initial Head-Label'
        self.HeadLabel = Label()
        self.HeadLabel.set_size_request(self.ParentWidh , self.heightHeadLabel)
        self.HeadLabel.set_alignment(0.5,0.5)
        self.HeadLabel.modify_font(pangoFontHead)
        self.put(self.HeadLabel, 2, topHeadLabel)
        self.HeadLabel.show()

        'initial Body-Label'
        self.BodyLabel = Label()
        self.BodyLabel.set_size_request(width, heightBodyLabel)
        self.BodyLabel.set_alignment(0,0)
        self.BodyLabel.set_line_wrap(True)
        self.BodyLabel.modify_font(pangoFontBody)
        self.put(self.BodyLabel, leftHeadLabel, topBodyLabel)
        self.BodyLabel.show()

        'Initial Comment Label'

        self.CommentLabel = Label()
        self.CommentLabel.set_size_request(self.ParentWidh , heightCommentLabel + 9)
        self.CommentLabel.modify_font(pangoCommentFont)
        self.CommentLabel.set_alignment(0,0.5)
        self.CommentLabel.set_line_wrap(True)
        self.put(self.CommentLabel, leftCommentLabel, topCommentLabel-9)
        self.CommentLabel.show()

        'Initial Auftritt Label'
        self.AppearanceTimeLabel = Label()
        self.AppearanceTimeLabel.set_size_request(self.ParentWidh/2, heightCommentLabel)
        self.AppearanceTimeLabel.set_alignment(0,0.5)
        self.AppearanceTimeLabel.modify_font(pangoFontBody)
        self.put(self.AppearanceTimeLabel, leftCommentLabel, topAppearanceLabel)
        self.AppearanceTimeLabel.show()

        'Initial PGM Label'
        self.PgmLabel = Label()
        self.PgmLabel.set_size_request(self.ParentWidh/2, heightCommentLabel)
        self.PgmLabel.set_alignment(1,0.5)
        self.PgmLabel.modify_font(pangoFontBody)
        self.put(self.PgmLabel, self.ParentWidh/2, topAppearanceLabel)
        self.PgmLabel.show()

        'Next Time Maintenance Label'
        self.nextTimeMaintenanceLabel = Label()
        self.nextTimeMaintenanceLabel.set_size_request(self.ParentWidh/2, heightCommentLabel)
        self.nextTimeMaintenanceLabel.set_alignment(0,0.5)
        self.nextTimeMaintenanceLabel.modify_font(pangoFontBody)
        color = self.nextTimeMaintenanceLabel.get_colormap().alloc_color(self.headColorsBLUE)
        self.nextTimeMaintenanceLabel.modify_fg(gtk.STATE_NORMAL, color)

        self.put(self.nextTimeMaintenanceLabel, leftCommentLabel, topAppearanceLabel)
        self.nextTimeMaintenanceLabel.hide()

        'Next Time Inspektion Label'
        self.nextTimeInspektionLabel = Label()
        self.nextTimeInspektionLabel.set_size_request(self.ParentWidh/2, heightCommentLabel)
        self.nextTimeInspektionLabel.set_alignment(1,0.5)
        self.nextTimeInspektionLabel.modify_font(pangoFontBody)
        self.nextTimeInspektionLabel.modify_fg(gtk.STATE_NORMAL, color)
        self.put(self.nextTimeInspektionLabel, self.ParentWidh/2, topAppearanceLabel)
        self.nextTimeInspektionLabel.hide()

        'Next Button'
        self.NextButton = Button()
        self.NextButton.connect("clicked", self.onButtonClicked)
        self.Nextimage = Image()
        self.Nextimage.set_from_file(ICNON_SYNTAX + "next.png")
        self.Nextimage.set_alignment(0.5, 0.5)
        self.Nextimage.show()

        self.NextGrayimage = Image()
        self.NextGrayimage.set_from_file(ICNON_SYNTAX + "next_gray.png")
        self.NextGrayimage.set_alignment(0.5, 0.5)
        self.NextButton.set_size_request(widthButton, heightVutton)
        self.put(self.NextButton, leftButton, topNextButton)
        self.NextGrayimage.hide()

        self.put(self.Nextimage, leftButton + 34, topNextButton + 24)
        self.put(self.NextGrayimage, leftButton + 34, topNextButton + 24)
        self.NextButton.show()

        'Ignor Button'
        self.IgnorButton = ToggleButton()
        self.IgnorButton.connect("clicked", self.onButtonClicked)
        self.IgnorImage = gtk.Image()
        self.IgnorImage.set_from_file(ICNON_SYNTAX + "cancel.png")
        self.IgnorImage.set_alignment(0.5, 0.5)

        self.IgnorImageGrayButton = Image()
        self.IgnorImageGrayButton.set_from_file(ICNON_SYNTAX + "cancel_gray.png")
        self.IgnorImageGrayButton.set_alignment(0.5, 0.5)

        'initial Reset-Icon'
        self.Resetimage = Image()
        self.Resetimage.set_from_file(ICNON_SYNTAX + "reset.png")
        self.Resetimage.set_alignment(0.5, 0.5)

        self.IgnorButton.set_size_request(widthButton, heightVutton)
        self.put(self.IgnorButton, leftButton, topNextButton + heightVutton)
        self.IgnorButton.show()
        self.IgnorImage.hide()
        self.IgnorImageGrayButton.hide()
        self.Resetimage.hide()

        self.put(self.IgnorImage, leftButton + 34, topNextButton + heightVutton + 24)
        self.put(self.IgnorImageGrayButton, leftButton + 34, topNextButton + heightVutton + 24)
        self.put(self.Resetimage, leftButton + 25, topNextButton + heightVutton + 20)


        'OK Button'
        self.OKButton = ToggleButton()
        self.OKButton.connect("clicked", self.onButtonClicked)

        self.OKImage = Image()
        self.OKImage.set_from_file(ICNON_SYNTAX + "ok.png")
        self.OKImage.set_alignment(0.5, 0.5)

        self.OKGrayImage = Image()
        self.OKGrayImage.set_from_file(ICNON_SYNTAX + "ok_gray.png")
        self.OKGrayImage.set_alignment(0.5, 0.5)

        self.OKButton.set_size_request(widthButton, heightVutton)
        self.put(self.OKButton, leftButton, topNextButton + 2 * heightVutton)
        self.OKButton.show()
        self.OKImage.hide()
        self.OKGrayImage.hide()

        self.put(self.OKImage, leftButton + 30, (topNextButton + 2 * heightVutton) + 17)
        self.put(self.OKGrayImage, leftButton + 30, (topNextButton + 2 * heightVutton) + 17)

        'Initial Regstrierfenster Image'
        self.smartKeyImage = Image()
        pixbuf = gtk.gdk.pixbuf_new_from_file(ICNON_SYNTAX + "pwPanel.png")
        scaled_buf = pixbuf.scale_simple(widthSmartKeyImage , heightSmartKeyImage, gtk.gdk.INTERP_BILINEAR)
        self.smartKeyImage.set_from_pixbuf(scaled_buf)
        self.put(self.smartKeyImage, 0,0)
        self.smartKeyImage.hide()

        'Initial Smarticon 1 Image'
        self.smartIcon1Image = Image()
        pixbuf = gtk.gdk.pixbuf_new_from_file(ICNON_SYNTAX + "pwIcon.png")
        scaled_buf = pixbuf.scale_simple(KeyPWImage, KeyPWImage,gtk.gdk.INTERP_BILINEAR)
        self.smartIcon1Image.set_from_pixbuf(scaled_buf)
        self.put(self.smartIcon1Image, leftKeyPWImage,topKeyPWImage)
        self.smartIcon1Image.hide()

        'Initial Smarticon 2 Image'
        self.smartIcon2Image = Image()
        pixbuf = gtk.gdk.pixbuf_new_from_file(ICNON_SYNTAX + "skIcon.png")
        scaled_buf = pixbuf.scale_simple(KeyPWImage, KeyPWImage,gtk.gdk.INTERP_BILINEAR)
        self.smartIcon2Image.set_from_pixbuf(scaled_buf)
        self.put(self.smartIcon2Image, leftKeyPWImage, 80)
        self.smartIcon2Image.hide()


        'Regstrierfenster Text'
        self.SmartKeyText = Label()
        self.SmartKeyText.set_size_request(self.widthArea, heightCommentLabel)
        color = self.SmartKeyText.get_colormap().alloc_color(self.headColorsBLUE)
        self.SmartKeyText.set_alignment(0.5,0.5)
        self.SmartKeyText.modify_font(pangoFontBody)
        self.SmartKeyText.modify_fg(gtk.STATE_NORMAL, color)
        self.put(self.SmartKeyText, leftKeyPWImage, topSmartKeyText)
        self.SmartKeyText.show()

        'Area for SmartKey Entry'
        self.areaIDEntry = DrawingArea()
        self.areaIDEntry.set_size_request(0, 0)
        self.put(self.areaIDEntry, leftKeyPWImage + 57, 76)
        self.areaIDEntry.connect("expose-event", self.on_expose)
        self.areaIDEntry.show()

        self.areaPWEntry = DrawingArea()
        self.areaPWEntry.set_size_request(0, 0)
        self.put(self.areaPWEntry, leftKeyPWImage + 57, 123)
        self.areaPWEntry.connect("expose-event", self.on_expose)
        self.areaPWEntry.show()

        'Reset-Abgleich Icon für Gesamteinschaltzeit(UpTime)'
        self.UpTimeImage = Image()
        self.UpTimeImage.set_from_file(ICNON_SYNTAX + "clockU.png")
        self.UpTimeImage.set_alignment(0.5, 0.5)
        self.put(self.UpTimeImage, leftKeyPWImage + 10, 80)
        self.UpTimeImage.hide()

        'Reset-Abgleich Label für Gesamteinschaltzeit'
        self.ResetUpTimeLabel = Label()
        self.ResetUpTimeLabel.set_size_request(100, 28)
        self.eb = gtk.EventBox()
        self.eb.set_size_request(0,0)
        self.eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FF9A00"))
        self.eb.add(self.ResetUpTimeLabel)
        self.put(self.eb, leftKeyPWImage + 58, 80)
        self.ResetUpTimeLabel.show()
        self.eb.show()

        'Reset-Abgleich TextView für Gesamteinschaltzeit'
        self.ResetUpTimeTextView = TextView()
        self.ResetUpTimeTextView.set_size_request(96, 24)
        self.ResetUpTimeTextView.modify_font(pangoFontHead)
        self.ResetUpTimeTextView.set_pixels_above_lines(6)
        self.put(self.ResetUpTimeTextView, leftKeyPWImage + 60, 82)
        self.ResetUpTimeTextView.hide()
        self.ResetUpTimeTextView.connect("focus_in_event", self.onFocus)
        self.ResetUpTimeTextView.connect("key_press_event", self.onKeyPressed)
        self.ResetUpTimeTextView.connect("focus_out_event", self.onKillFocus)
        self.ResetUpTimeTextView.set_accepts_tab(False)
        self.ResetUpTimeBuffer = self.ResetUpTimeTextView.get_buffer()
        self.ResetUpTimeBuffer.connect('insert-text', self.onInsertText)

        '---------------------------------------'
        'Reset-Abgleich Icon für ProgrammlaufZeit'
        self.ProgrammRunTimeImage = Image()
        self.ProgrammRunTimeImage.set_from_file(ICNON_SYNTAX + "clockP.png")
        self.ProgrammRunTimeImage.set_alignment(0.5, 0.5)
        self.put(self.ProgrammRunTimeImage, leftKeyPWImage + 60 +120 , 80)
        self.ProgrammRunTimeImage.hide()

        'Reset-Abgleich Label für Gesamteinschaltzeit'
        self.ResetPgmTimeLabel = Label()
        self.ResetPgmTimeLabel.set_size_request(100, 28)
        self.ebPgm = gtk.EventBox()
        self.ebPgm.set_size_request(0,0)
        self.ebPgm.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FF9A00"))
        self.ebPgm.add(self.ResetPgmTimeLabel)
        self.put(self.ebPgm, leftKeyPWImage + 240, 80)
        self.ResetPgmTimeLabel.show()
        self.ebPgm.show()

        'Reset-Abgleich TextView für Gesamteinschaltzeit'
        self.ResetPgmTextView = TextView()
        self.ResetPgmTextView.set_size_request(96, 24)
        self.ResetPgmTextView.modify_font(pangoFontHead)
        self.ResetPgmTextView.set_pixels_above_lines(6)
        self.put(self.ResetPgmTextView, leftKeyPWImage + 242, 82)
        self.ResetPgmTextView.hide()
        self.ResetPgmTextView.connect("focus_in_event", self.onFocus)
        self.ResetPgmTextView.connect("key_press_event", self.onKeyPressed)
        self.ResetPgmTextView.connect("focus_out_event", self.onKillFocus)
        self.ResetPgmTextView.set_accepts_tab(False)
        self.ResetPgmTimeBuffer = self.ResetPgmTextView.get_buffer()
        self.ResetPgmTimeBuffer.connect('insert-text', self.onInsertText)

        'Regstrierfenster Eingabefelder definieren'
        self.EntrySmartID = TextView()
        self.EntrySmartID.set_size_request(290, 26)
        self.EntrySmartID.modify_font(pangoFontHead)
        self.EntrySmartID.set_pixels_above_lines(6)
        self.put(self.EntrySmartID, leftKeyPWImage + 60, 78)
        self.EntrySmartID.hide()
        self.EntrySmartID.connect("focus_in_event", self.onFocus)
        self.EntrySmartID.connect("key_press_event", self.onKeyPressed)
        self.EntrySmartID.connect("focus_out_event", self.onKillFocus)
        self.EntrySmartID.set_accepts_tab(False)
        self.IDBuffer = self.EntrySmartID.get_buffer()
        self.IDBuffer.connect('insert-text', self.onInsertText)

        self.EntrySmartPW = TextView()
        self.EntrySmartPW.set_size_request(290, 26)
        self.EntrySmartPW.modify_font(pangoFontHead)
        self.put(self.EntrySmartPW, leftKeyPWImage + 60, 125)
        self.EntrySmartPW.set_pixels_above_lines(6)
        self.EntrySmartPW.hide()
        self.EntrySmartPW.connect("focus_in_event", self.onFocus)
        self.EntrySmartPW.connect("key_press_event", self.onKeyPressed)
        self.EntrySmartPW.connect("focus_out_event", self.onKillFocus)
        self.EntrySmartPW.set_accepts_tab(False)
        self.PWBuffer = self.EntrySmartPW.get_buffer()
        self.PWBuffer.connect('insert-text', self.onInsertText)

        'create Entry'
        self.show()
        'DMGmachineCheckData starten'
        gobject.timeout_add(50, self.onHideAllImages)

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Die Klasse erzeut ein neues WindowFenster und testet die Funktionalität weitere Klassen
Autor: Waddah Ostah
Datum: 1.12.2010
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
class DMGMainSample:
    def __init__(self):
        window = Window(WINDOW_TOPLEVEL)
        checkView = MachineCheckView(None)

        window.connect('destroy', lambda *w: main_quit())
        window.add(checkView)
        window.show()
        window.set_keep_above(True)

def main_():
    main()
    return 0

if __name__ == "__main__":
    DMGMainSample()
    main_()
